#ifndef _Elm_Struct_Data_h              /* compiler directives */
#define _Elm_Struct_Data_h
/* E6jul13             ( follows  E1mar06.h, and E1oct99.h) 3-Feb-2013  VAPORS9 code
|
| MASTER element data file. Part of "Els[]" data structure is set here. Part is done in code.
|                           This header occurs ONLY in the module containing 'main'.
|
|13-Jul-99: Print data from 'VAPORS3' to this file, NEW FORMAT.
|26-Jul-99: Add 'deuterium' after U at end of file.
|17-Sep-99: Add Tmelt + Tboil data from CRC Handbook #52 (1971-2).
| 1-Oct-99: Add some data. Change name to 'E1oct99' from 'e13jul99'
|           New regressions gef: Cd
| 1-Feb-02: Rename E1feb02.h for new work.
|30-Mar-06: Rename E1mar06.h for new work.
|28-Jan-13: Add Electron data. Called 'electron' and 'e-'. Place after Uranium.
| 3-Feb-13: Rename to "E2feb13.h"  
| 5-Jul-13: Rename to "E5jul13.h" 
|			Add 25 - 298.15 K info for H. To test. Add coefficient f for T^(-3) = modHKF to address lowest T.
|           Re-do to make 6 coefficients per regression!
| 7-Jul-13: Actual regressions of element GEF info etc. and new formating.
|			Need to re-brand in:  VaporsX.c and also in definition of element structure in CoreData2.h

|GENERAL INFO:
|All elements are regressed from 298.15 K to above 2800 K, almost all to 3000 K.
|MISSING:  Thallium (as of 22april2013)
|FORMATS:
| line1:
|	1a  symbol... no blanks!; Elements must be in order of atomic weight!   
|   1b  z         atomic number
|   1c  name      text string element name
|   1d  atom wt.  atomic wt.
|   1e  flag: data ok? (T/F)
| line2: sol abund, 
|   2a  abundSol..Anders & Grevesse (89) SOLAR abundance data;
|   2b  Orgueil abunds.(AG89 to 10^6)
|   2c  flag present?(T/F)
| line 3: data
|   Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) 
|   (The H, S, G data are for the monatomic gas, in most cases. This must be verified)
| line 4: reference
| line 5: comment
| line 6-11: Thermo data (JANAF tables; older version has Robie et al data):
|   These are Tmin, Tmax, and regressions for G functions (Giauque functions).
|   OLD regressions: JANAF (Gfunction = fG = -[G(T)-H(298)]/T = a + b*T^(-0.5) + c/T + d/(T*T)
|   NEW regressions of HKF (Haas-Kennedy-Fisher) form for Giaque function (Gef):
|      Tmin, Tmax, a, b, c, d, e    for 'Gef = a + b*t + c/(t*t) + f*t*t + g/sqrt(t)'
|  NOTE: The rest of the variables in 'els' are NOT set here, but are done in code.
  ----- 
 JANAF ELEMENT data: Regressions:   Mon Feb 17 23:00:33 1997
 NEW regressions for ELEMENTS database 
 error measure err = (sum[y(new)-y(true)]^2)^(0.5)/N 
 Haas/Fisher(HKF): -[G(T)-H(298)]/T = Gef = a + bT + cT^(-2) + dT^2 + eT^(-0.5)
 Change: Jul 5 2013 to new form:
 modified HKF: -[G(T)-H(298)]/T = Gef = a + bT + cT^(-2) + dT^2 + eT^(-0.5) + fT^(-3) for lowest T.
 (these are used in Pgas18.cpp in 'congas' routine.
-----
*/
Els els[] = {
{"!", 0, "nullElement", 0.0, 0,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Null Element",
   "null comment",
      298.150,       0.0,      +0.0,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
},
{"H",  1, "hydrogen", 1.007900, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "H2(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:24:44 2013
 "... further comment...",
      298.150,  +8.46700, +130.68000,   // Tref H298(kJ) & S298(J) ref. element (note: H(298 K) = -(H-H(Tr) column at (0 K)
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +4.56403030e+001, +1.56533349e-001, +1.61054549e+005, -1.13680844e-004, +8.06624994e+002, -1.49940518e+006, //err=+3.470e-003
     298.150,  800.000, +1.17649351e+002, +3.83658311e-002, +5.14897986e+005, -9.23945855e-006, -5.83457594e+001, +4.67379181e+003, //err=+3.456e-004
     800.000, 2300.000, +1.61790756e+002, +1.17660024e-002, +2.06102542e+006, -7.96589553e-007, -9.26095221e+002, +4.57720089e+003, //err=+2.029e-004
    2300.000, 3000.000, +1.64767985e+002, +1.01158415e-002, -2.24476932e-002, -5.18553445e-007, -9.38650437e+002, -1.43559563e-005, //err=+8.619e-005
    3000.000, 4000.000, +1.73784788e+002, +8.15311890e-003, -1.90267813e-002, -3.26074164e-007, -1.20490853e+003, -9.23126493e-006, //err=+7.302e-005
    4000.000, 5000.000, +1.85406545e+002, +6.20611167e-003, -1.71448240e-002, -1.78697320e-007, -1.59648670e+003, -6.42175454e-006, //err=+9.640e-005
    5000.000, 6000.000, +1.83541618e+002, +6.39368739e-003, -1.20019133e-002, -1.86788498e-007, -1.51662925e+003, -3.66434845e-006, //err=+7.290e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"He",  2, "helium", 4.002600, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "He1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:24:49 2013
 "... further comment...",
      298.150,  +6.19700, +126.15200,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +4.91767011e+001, +1.53227989e-001, +1.03392600e+005, -1.30331515e-004, +7.20740976e+002, -9.49459538e+005, //err=+5.632e-003
     298.150,  800.000, +1.17338813e+002, +2.70566480e-002, +3.73498282e+005, -6.53824730e-006, -4.96286100e+001, +3.39028950e+003, //err=+2.518e-004
     800.000, 2300.000, +1.50972420e+002, +7.72197004e-003, +1.68558922e+006, -6.31076810e-007, -7.28323349e+002, +3.74341839e+003, //err=+2.256e-004
    2300.000, 3000.000, +1.53019173e+002, +6.37059395e-003, -1.73036898e-002, -3.88732165e-007, -7.23553901e+002, -1.10662156e-005, //err=+6.950e-005
    3000.000, 4000.000, +1.60825336e+002, +4.61148988e-003, -1.50019742e-002, -2.10303590e-007, -9.50029663e+002, -7.27854050e-006, //err=+8.628e-005
    4000.000, 5000.000, +1.69586550e+002, +3.14945899e-003, -1.33793800e-002, -1.00030965e-007, -1.24585719e+003, -5.01137220e-006, //err=+8.927e-005
    5000.000, 6000.000, +1.71052864e+002, +2.95617543e-003, -1.02965833e-002, -8.87627804e-008, -1.30113415e+003, -3.14368784e-006, //err=+6.591e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Li",  3, "lithium", 6.940000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Li1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:24:51 2013
 "... further comment...",
      298.150,  +4.62200, +29.08500,   // Tref H298(kJ) & S298(J) ref. element 
      453.690,  +3.00000,  +6.61400,   // T(K) H(kJ) S(J) melt 
     1620.120, +145.84300, +90.02000,   // T(K) H(kJ) S(J) vapor
      25.000,  107.250, -1.18485491e+002, +4.25292085e-001, +2.09871630e+004, -7.32759816e-004, +1.29798529e+003, +1.63506576e+003, //err=+1.371e-011
     107.250,  298.150, -4.43267077e+001, +1.23200731e-001, +7.72839734e+004, -7.71370497e-005, +7.36730528e+002, +1.83131502e+003, //err=+9.645e-009
     298.150,  453.690, -2.16634739e-001, +4.70291958e-002, +2.38842929e+005, -1.05303772e-005, +2.33601910e+002, +1.81655120e+003, //err=+7.604e-005
     453.690,  800.000, +4.42567710e+001, +2.53833524e-002, +7.45073439e+005, -5.10361979e-006, -5.80685484e+002, +3.54423603e+003, //err=+6.477e-005
     800.000, 1620.120, +6.63859663e+001, +1.26884190e-002, +1.55758003e+006, -1.30144601e-006, -1.02407181e+003, +3.94115421e+003, //err=+9.541e-005
    1620.120, 2300.000, +4.05948340e+002, -3.39969300e-002, -1.85441461e+000, +3.68465615e-006, -1.21501778e+004, -2.43032219e-003, //err=+2.017e-004
    2300.000, 3000.000, +3.48846415e+002, -1.70341912e-002, -2.56016441e-001, +1.40868482e-006, -1.07053291e+004, -1.63730001e-004, //err=+1.282e-004
    3000.000, 4000.000, +3.16360262e+002, -9.78365802e-003, -1.54084295e-001, +6.79019133e-007, -9.75769250e+003, -7.47574132e-005, //err=+7.776e-005
    4000.000, 5000.000, +2.94376603e+002, -5.93513169e-003, -9.70201765e-002, +3.75985000e-007, -9.03429640e+003, -3.63398167e-005, //err=+7.940e-005
    5000.000, 6000.000, +2.81298057e+002, -4.08326113e-003, -6.77066280e-002, +2.58066204e-007, -8.55579020e+003, -2.06717605e-005, //err=+8.023e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Be",  4, "beryllium", 9.012180, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Be1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:24:53 2013
 "... further comment...",
      298.150,  +1.93200,  +9.44000,   // Tref H298(kJ) & S298(J) ref. element 
     1560.000,  +7.89500,  +5.06100,   // T(K) H(kJ) S(J) melt 
     2741.437, +291.57200, +106.35700,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -2.49392986e+001, +4.14105750e-002, +2.17815069e+004, -4.01738624e-006, +3.82497422e+002, -1.58567765e+005, //err=+7.157e-004
     298.150,  800.000, -1.15162555e+001, +3.35365207e-002, +1.74551804e+005, -7.41425649e-006, +1.66678517e+002, +1.58442717e+003, //err=+2.834e-004
     800.000, 1527.000, +2.02094155e+001, +1.37662455e-002, +1.16216873e+006, -1.01833555e-006, -4.42719476e+002, +3.01344336e+003, //err=+9.696e-005
    1527.000, 1560.000, +2.61149341e-005, +2.01518969e-002, +2.19308051e-011, -1.17808403e-006, +0.00000000e+000, +3.01344336e+003, //err=+4.102e-007
    1560.000, 2300.000, +5.70644066e+001, +8.33573703e-003, -2.49701253e-001, -5.17450505e-007, -1.58931180e+003, -3.33966990e-004, //err=+5.451e-005
    2300.000, 2741.437, +5.84266142e+001, +7.84019499e-003, -4.12709832e-002, -4.39982975e-007, -1.61962940e+003, -2.74774316e-005, //err=+7.831e-005
    2741.437, 3000.000, +5.91291363e+002, -5.36811247e-002, -4.72510898e-001, +4.50983913e-006, -2.26368552e+004, -2.74774316e-005, //err=+8.921e-010
    3000.000, 4000.000, +4.55981153e+002, -2.32397130e-002, -2.95398661e-001, +1.42452254e-006, -1.87067040e+004, -1.43319212e-004, //err=+1.698e-004
    4000.000, 5000.000, +4.00856733e+002, -1.38673780e-002, -1.81103951e-001, +7.05682763e-007, -1.68639847e+004, -6.78341827e-005, //err=+5.750e-005
    5000.000, 6000.000, +3.70832092e+002, -9.79237685e-003, -1.24571239e-001, +4.56707419e-007, -1.57415221e+004, -3.80333047e-005, //err=+8.616e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"B",  5, "boron", 10.810000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "B1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:24:53 2013
 "... further comment...",
      298.150,  +1.21400,  +5.83400,   // Tref H298(kJ) & S298(J) ref. element 
     2350.000, +50.20800, +21.36500,   // T(K) H(kJ) S(J) melt 
     4139.449, +480.50900, +116.08100,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -1.51837315e+001, +2.39854312e-002, +1.38043497e+004, -2.76281619e-007, +2.37164339e+002, -9.97278761e+004, //err=+7.569e-004
     298.150,  800.000, -1.99829622e+001, +3.24086447e-002, +2.98048956e+003, -6.98624276e-006, +2.89088002e+002, +2.74693968e+001, //err=+1.460e-004
     800.000, 2300.000, +1.81762650e+001, +1.14142465e-002, +1.60816549e+006, -8.32769101e-007, -4.97414488e+002, +3.54019293e+003, //err=+1.979e-004
    2300.000, 2350.000, +8.01600000e+000, +9.54000000e-003, +4.44989814e-006, +0.00000000e+000, +0.00000000e+000, +3.54019293e+003, //err=+1.611e-007
    2350.000, 3000.000, +9.16657703e+001, +4.51121860e-003, -8.09051803e-002, -2.09015677e-007, -3.42623476e+003, -5.12763409e-005, //err=+6.165e-005
    3000.000, 4000.000, +9.58393439e+001, +3.56057866e-003, -5.60132199e-002, -1.10572076e-007, -3.54714785e+003, -2.71760559e-005, //err=+6.754e-005
    4000.000, 4139.449, -7.82539012e+000, +2.03527049e-002, +1.20965207e-012, -1.33490184e-006, +0.00000000e+000, -2.71760559e-005, //err=+9.795e-012
    4139.449, 5000.000, +5.68395609e+002, -2.42086165e-002, -2.92909060e-001, +1.10784060e-006, -2.78983545e+004, -1.07998189e-004, //err=+7.354e-005
    5000.000, 6000.000, +5.05686436e+002, -1.58035428e-002, -2.02094239e-001, +5.99838499e-007, -2.55377643e+004, -6.17021381e-005, //err=+8.983e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"C",  6, "carbon", 12.011000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "C1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:24:54 2013
 "... further comment...",
      298.150,  +1.05100,  +5.74000,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +5.86809984e+001, -1.74365521e-001, +1.06801406e+005, +2.53210561e-004, -4.23804178e+002, -1.53966192e+006, //err=+5.945e-002
     298.150,  800.000, -1.31869496e+001, +2.29725205e-002, -4.36165261e+003, -3.94137700e-006, +2.15448979e+002, -3.95922149e+001, //err=+9.086e-005
     800.000, 2300.000, +1.21719374e+001, +1.07621236e-002, +1.28587068e+006, -8.61125957e-007, -3.38265601e+002, +2.85570879e+003, //err=+3.294e-004
    2300.000, 3000.000, +1.87564442e+001, +8.19383958e-003, -1.10078963e-002, -4.61924688e-007, -4.60295257e+002, -7.03987162e-006, //err=+7.048e-005
    3000.000, 4000.000, +2.69227061e+001, +6.34872878e-003, -1.10074005e-002, -2.73946921e-007, -6.97065391e+002, -5.34048449e-006, //err=+5.542e-005
    4000.000, 5000.000, +3.56308339e+001, +4.83155008e-003, -1.05756838e-002, -1.54575811e-007, -9.84783430e+002, -3.96122152e-006, //err=+7.196e-005
    5000.000, 6000.000, +4.55356438e+001, +3.51478622e-003, -1.07560638e-002, -7.56183928e-008, -1.35919670e+003, -3.28397355e-006, //err=+7.240e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"N",  7, "nitrogen", 14.006700, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "N2(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:24:55 2013
 "... further comment...",
      298.150,  +8.67000, +191.60900,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +8.38400861e+001, +2.14485529e-001, +1.44804445e+005, -1.82386907e-004, +1.00914139e+003, -1.32987155e+006, //err=+7.918e-003
     298.150,  800.000, +1.80539905e+002, +3.60447973e-002, +5.30193771e+005, -7.77082514e-006, -8.54850926e+001, +4.81263365e+003, //err=+3.245e-004
     800.000, 2300.000, +2.18705224e+002, +1.42788235e-002, +2.06652083e+006, -1.13282390e-006, -8.60466588e+002, +4.57708052e+003, //err=+2.838e-004
    2300.000, 3000.000, +2.26000034e+002, +1.12492115e-002, -2.33230017e-002, -6.55167771e-007, -9.78519926e+002, -1.48823330e-005, //err=+6.600e-005
    3000.000, 4000.000, +2.38849081e+002, +8.39686357e-003, -2.13931542e-002, -3.68805185e-007, -1.35476377e+003, -1.03793632e-005, //err=+8.582e-005
    4000.000, 5000.000, +2.52424891e+002, +6.14686651e-003, -1.94879184e-002, -2.00319401e-007, -1.81467028e+003, -7.29938252e-006, //err=+6.097e-005
    5000.000, 6000.000, +2.56450062e+002, +5.59093344e-003, -1.55405495e-002, -1.65784646e-007, -1.96379122e+003, -4.74474254e-006, //err=+8.487e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"O",  8, "oxygen", 15.999400, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "O2(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:24:57 2013
 "... further comment...",
      298.150,  +8.68300, +205.14700,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +9.75348832e+001, +2.14060167e-001, +1.45509871e+005, -1.82217749e-004, +1.00800827e+003, -1.34014316e+006, //err=+6.399e-003
     298.150,  800.000, +1.89929586e+002, +3.95424345e-002, +4.90196579e+005, -8.41717171e-006, -2.31032603e+001, +4.44957400e+003, //err=+2.142e-004
     800.000, 2300.000, +2.36479703e+002, +1.43171253e-002, +2.51938191e+006, -1.10611505e-006, -9.90925057e+002, +5.59513580e+003, //err=+4.205e-004
    2300.000, 3000.000, +2.41719160e+002, +1.16255934e-002, -2.48278879e-002, -6.49634041e-007, -1.03817830e+003, -1.58781604e-005, //err=+9.213e-005
    3000.000, 4000.000, +2.52849258e+002, +9.08716746e-003, -2.14640025e-002, -3.88826135e-007, -1.35925037e+003, -1.04137368e-005, //err=+9.142e-005
    4000.000, 5000.000, +2.69751995e+002, +6.27894329e-003, -2.07426968e-002, -1.77677757e-007, -1.93151237e+003, -7.76937153e-006, //err=+6.104e-005
    5000.000, 6000.000, +2.76861327e+002, +5.38066753e-003, -1.74568407e-002, -1.27159390e-007, -2.20594455e+003, -5.32981248e-006, //err=+7.305e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"F",  9, "fluorine", 18.998403, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "F2(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:24:59 2013
 "... further comment...",
      298.150,  +8.82500, +202.78900,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +9.37092278e+001, +2.13149814e-001, +1.47581832e+005, -1.76643075e-004, +1.02931067e+003, -1.35723120e+006, //err=+8.134e-003
     298.150,  800.000, +1.81349329e+002, +4.74307618e-002, +4.81714223e+005, -1.09789576e-005, +4.93080725e+001, +4.37257830e+003, //err=+3.702e-004
     800.000, 2300.000, +2.38634342e+002, +1.49596439e-002, +2.76064598e+006, -1.20101776e-006, -1.11387999e+003, +6.11447934e+003, //err=+3.145e-004
    2300.000, 3000.000, +2.43165464e+002, +1.25448941e-002, -2.72401826e-002, -7.94391112e-007, -1.14286582e+003, -1.73818736e-005, //err=+8.176e-005
    3000.000, 4000.000, +2.55073360e+002, +9.94663802e-003, -2.35887720e-002, -5.39477218e-007, -1.49380560e+003, -1.14446159e-005, //err=+7.539e-005
    4000.000, 5000.000, +2.75455755e+002, +6.51283339e-003, -2.33945751e-002, -2.78353060e-007, -2.17844920e+003, -8.76265743e-006, //err=+8.926e-005
    5000.000, 6000.000, +2.88441913e+002, +4.77104862e-003, -2.11037406e-002, -1.73202144e-007, -2.66678732e+003, -6.44326093e-006, //err=+7.336e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ne", 10, "neon", 20.179000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Ne1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:00 2013
 "... further comment...",
      298.150,  +6.19700, +146.32700,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +6.92913974e+001, +1.53419633e-001, +1.03313379e+005, -1.30622991e-004, +7.21258084e+002, -9.48209118e+005, //err=+5.620e-003
     298.150,  800.000, +1.37544657e+002, +2.70316061e-002, +3.73812001e+005, -6.53015261e-006, -5.00965869e+001, +3.39313716e+003, //err=+2.878e-004
     800.000, 2300.000, +1.70905354e+002, +7.79531560e-003, +1.66097635e+006, -6.41757900e-007, -7.21852494e+002, +3.68875723e+003, //err=+2.283e-004
    2300.000, 3000.000, +1.73001891e+002, +6.45307493e-003, -1.72211026e-002, -4.01886517e-007, -7.20100519e+002, -1.10133987e-005, //err=+6.886e-005
    3000.000, 4000.000, +1.82835557e+002, +4.26337703e-003, -1.59165491e-002, -1.80697341e-007, -1.00794693e+003, -7.72226679e-006, //err=+6.509e-005
    4000.000, 5000.000, +1.87225099e+002, +3.53373803e-003, -1.24159538e-002, -1.26187319e-007, -1.15614515e+003, -4.65051189e-006, //err=+5.919e-005
    5000.000, 6000.000, +1.95644419e+002, +2.42005086e-003, -1.16765553e-002, -5.95535072e-008, -1.47551517e+003, -3.56501219e-006, //err=+6.662e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Na", 11, "sodium", 22.989770, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Na1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:01 2013
 "... further comment...",
      298.150,  +6.44700, +51.45500,   // Tref H298(kJ) & S298(J) ref. element 
      370.980,  +2.60300,  +7.01700,   // T(K) H(kJ) S(J) melt 
     1170.525, +97.02200, +82.88800,   // T(K) H(kJ) S(J) vapor
      25.000,   55.120, +5.02870328e+002, -1.21331144e+001, +2.12255805e+000, +9.44562166e-002, +0.00000000e+000, -3.23400446e+006, //err=+5.259e+001
      55.120,  298.150, -2.50394420e+001, +1.37249733e-001, +1.71787944e+005, -9.29964792e-005, +7.25282268e+002, -2.57968626e+006, //err=+1.095e-003
     298.150,  370.980, -4.64430462e+001, +1.51966828e-001, +2.25967557e+000, -8.59740185e-005, +1.04002089e+003, -2.57968626e+006, //err=+3.306e-002
     370.980,  800.000, +6.28069490e+001, +3.01947853e-002, +6.40852799e+005, -6.91179273e-006, -4.93381145e+002, +3.45216321e+003, //err=+1.186e-004
     800.000, 1170.525, +1.04802614e+002, +5.82292737e-003, +2.11059748e+006, +4.17283714e-007, -1.32734799e+003, +6.09573098e+003, //err=+6.964e-010
    1170.525, 2300.000, +2.82716242e+002, -7.06423811e-003, -1.19455993e+007, +7.63320644e-007, -6.56343084e+003, -2.10090976e+004, //err=+7.943e-005
    2300.000, 3000.000, +3.05710619e+002, -9.81621456e-003, -1.79285792e-001, +8.65356771e-007, -7.49683655e+003, -1.14658507e-004, //err=+1.286e-004
    3000.000, 4000.000, +2.83739670e+002, -4.91493795e-003, -1.08256220e-001, +3.71859502e-007, -6.85553909e+003, -5.25229062e-005, //err=+5.172e-005
    4000.000, 5000.000, +2.74078838e+002, -3.28924855e-003, -7.01376885e-002, +2.48595081e-007, -6.53106075e+003, -2.62707288e-005, //err=+1.047e-004
    5000.000, 6000.000, +2.56445697e+002, -1.05628134e-003, -4.62841873e-002, +1.21348788e-007, -5.84873014e+003, -1.41311961e-005, //err=+1.682e-004
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Mg", 12, "magnesium", 24.305000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Mg1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:03 2013
 "... further comment...",
      298.150,  +4.99800, +32.67100,   // Tref H298(kJ) & S298(J) ref. element 
      923.000,  +8.47700,  +9.18400,   // T(K) H(kJ) S(J) melt 
     1366.104, +127.86700, +93.60000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.24438702e+001, +1.81310045e-001, +7.27801284e+004, -1.48372240e-004, +9.22842177e+002, -6.72326538e+005, //err=+5.572e-003
     298.150,  800.000, +1.88679165e+001, +3.43628882e-002, +4.13537183e+005, -7.06291522e-006, -8.05198914e+000, +3.75372725e+003, //err=+3.606e-004
     800.000,  923.000, +2.27501760e+001, +2.69365288e-002, +1.80132088e-004, -3.28031107e-006, +0.00000000e+000, +3.75372725e+003, //err=+2.804e-006
     923.000, 1366.104, +7.28142506e+001, +1.49895350e-002, +1.72939923e+006, -1.54943413e-006, -1.29245130e+003, +4.33364471e+003, //err=+1.141e-004
    1366.104, 2300.000, +4.15330972e+002, -3.71329355e-002, -2.04721698e+000, +4.33692688e-006, -1.16920462e+004, -2.95692612e-003, //err=+1.098e-003
    2300.000, 3000.000, +3.44608357e+002, -1.51622270e-002, -2.37745081e-001, +1.25190190e-006, -9.94131213e+003, -1.52044932e-004, //err=+5.176e-005
    3000.000, 4000.000, +3.13430104e+002, -8.22333358e-003, -1.42595157e-001, +5.54773861e-007, -9.03012011e+003, -6.91832029e-005, //err=+1.227e-004
    4000.000, 5000.000, +2.95382725e+002, -5.17491445e-003, -9.04777564e-002, +3.22711049e-007, -8.42508124e+003, -3.38892919e-005, //err=+8.761e-005
    5000.000, 6000.000, +2.85789624e+002, -3.87600531e-003, -6.38331574e-002, +2.43699690e-007, -8.06631668e+003, -1.94891369e-005, //err=+7.014e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Al", 13, "aluminum", 26.981540, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Al1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:04 2013
 "... further comment...",
      298.150,  +4.53900, +28.27500,   // Tref H298(kJ) & S298(J) ref. element 
      933.450, +10.71100, +11.47500,   // T(K) H(kJ) S(J) melt 
     2790.812, +294.00200, +105.34700,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.12773342e+001, +1.66062882e-001, +6.04690724e+004, -1.30533056e-004, +8.80236915e+002, -5.30697442e+005, //err=+4.244e-003
     298.150,  800.000, +1.42598682e+001, +3.40492418e-002, +4.01036039e+005, -6.94552208e-006, -5.18925390e-001, +3.64025281e+003, //err=+3.702e-004
     800.000,  933.450, +1.84468696e+001, +2.65536413e-002, +1.45048796e-004, -3.16684784e-006, +0.00000000e+000, +3.64025281e+003, //err=+2.687e-006
     933.450, 2300.000, +8.45105484e+001, +9.65859231e-003, +1.89915250e+006, -7.16799174e-007, -1.66837696e+003, +3.84653067e+003, //err=+1.285e-004
    2300.000, 2790.812, +8.79578117e+001, +7.96319719e-003, -4.26911288e-002, -4.42335052e-007, -1.69908095e+003, -2.81687444e-005, //err=+7.896e-005
    2790.812, 3000.000, +6.60321303e+002, -6.22530753e-002, -4.92769404e-001, +5.36854427e-006, -2.39746914e+004, -2.81687444e-005, //err=+2.166e-010
    3000.000, 4000.000, +4.87762144e+002, -2.32830968e-002, -2.99594143e-001, +1.40417284e-006, -1.89723912e+004, -1.45354743e-004, //err=+1.621e-004
    4000.000, 5000.000, +4.31442823e+002, -1.36236637e-002, -1.83616294e-001, +6.56865832e-007, -1.70979283e+004, -6.87752044e-005, //err=+6.582e-005
    5000.000, 6000.000, +3.92129812e+002, -8.33876824e-003, -1.23607649e-001, +3.36230149e-007, -1.56197575e+004, -3.77391076e-005, //err=+8.037e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Si", 14, "silicon", 28.085500, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Si1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:06 2013
 "... further comment...",
      298.150,  +3.21800, +18.82000,   // Tref H298(kJ) & S298(J) ref. element (note: H(298 K) = -(H-H(Tr) column at (0 K)
     1685.000, +50.20800, +29.79700,   // T(K) H(kJ) S(J) melt 
     3504.616, +384.54800, +109.72600,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -5.57272814e+001, +1.39131696e-001, +2.34522790e+004, -1.13908682e-004, +7.41023898e+002, -7.30234060e+004, //err=+1.281e-002
     298.150,  800.000, +1.72648840e+000, +3.35489699e-002, +2.85054760e+005, -7.73872713e-006, +7.89484676e+001, +2.58747630e+003, //err=+2.840e-004
     800.000, 1685.000, +3.68480315e+001, +1.23106646e-002, +1.47336365e+006, -1.01627359e-006, -6.08061052e+002, +3.66996780e+003, //err=+7.973e-005
    1685.000, 2300.000, +1.44468414e+002, -1.44236100e-003, -6.22448355e-001, +3.88975173e-007, -4.21695930e+003, -7.96874003e-004, //err=+8.817e-005
    2300.000, 3000.000, +1.35569775e+002, +1.18814454e-003, -9.54445528e-002, +3.68271704e-008, -3.99101460e+003, -6.10395826e-005, //err=+6.272e-005
    3000.000, 3504.616, +1.31452822e+002, +2.08388339e-003, -6.70408213e-002, -5.16658903e-008, -3.86909104e+003, -3.45018047e-005, //err=+9.085e-005
    3504.616, 4000.000, +5.53128959e+002, -2.53856894e-002, -3.38704909e-001, +1.35774619e-006, -2.41578485e+004, -1.51302003e-004, //err=+3.100e-005
    4000.000, 5000.000, +5.12856541e+002, -1.89103280e-002, -2.44589439e-001, +8.89997714e-007, -2.27756078e+004, -9.16132674e-005, //err=+8.671e-005
    5000.000, 6000.000, +4.58126596e+002, -1.15216680e-002, -1.63988380e-001, +4.40049836e-007, -2.07224938e+004, -5.00678977e-005, //err=+7.896e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"P", 15, "phosphorous", 30.973760, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "P1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:08 2013
 "... further comment...",
      298.150,  +5.36000, +41.07700,   // Tref H298(kJ) & S298(J) ref. element 
      317.300,  +0.65900,  +2.07500,   // T(K) H(kJ) S(J) melt 
     1180.008, +63.72800, +54.00700,   // T(K) H(kJ) S(J) vapor
      25.000,  195.400, -5.32679851e+001, +1.78686769e-001, +7.37718618e+004, -1.67356630e-004, +9.27213809e+002, -6.10692609e+005, //err=+7.408e-009
     195.400,  298.150, -5.60040018e+001, +1.69555167e-001, +3.67976795e+000, -1.23393112e-004, +9.92800561e+002, -6.10692609e+005, //err=+2.918e-002
     298.150,  317.300, +5.05404724e+001, -6.38227577e-002, +3.26235078e-003, +1.07603943e-004, +0.00000000e+000, -6.10692609e+005, //err=+1.053e-002
     317.300,  800.000, +3.48120160e+001, +3.25559930e-002, +4.64857895e+005, -7.68928434e-006, -1.40044596e+002, +4.09027142e+003, //err=+2.219e-004
     800.000, 1180.008, +5.06877066e+001, +2.02375831e-002, +6.53761682e+005, -3.09382454e-006, -4.01869476e+002, +1.88279527e+003, //err=+1.599e-008
    1180.008, 2300.000, +2.00179650e+002, -3.28547425e-003, -7.39599584e+006, +4.25967460e-007, -4.55336935e+003, -1.29496282e+004, //err=+5.735e-005
    2300.000, 3000.000, +2.12001516e+002, -4.35063232e-003, -1.21160461e-001, +4.11944895e-007, -5.06632545e+003, -7.74856578e-005, //err=+6.793e-005
    3000.000, 4000.000, +2.00673251e+002, -1.84553447e-003, -7.47585411e-002, +1.61916777e-007, -4.73423236e+003, -3.62707642e-005, //err=+5.310e-005
    4000.000, 5000.000, +1.91769260e+002, -3.34110242e-004, -4.76423074e-002, +4.61936041e-008, -4.43634244e+003, -1.78448729e-005, //err=+7.754e-005
    5000.000, 6000.000, +1.90848452e+002, -1.96475395e-004, -3.48497505e-002, +3.70965141e-008, -4.40381042e+003, -1.06401060e-005, //err=+4.874e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"S", 16, "sulfur", 32.060000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "S1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:11 2013
 "... further comment...",
      298.150,  +4.41200, +32.05600,   // Tref H298(kJ) & S298(J) ref. element 
      388.360,  +1.72100,  +4.43200,   // T(K) H(kJ) S(J) melt 
      882.117, +53.32600, +60.45300,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -4.35021582e+001, +1.35886271e-001, +6.62289965e+004, -1.00300916e-004, +7.46496307e+002, -5.95281760e+005, //err=+3.366e-003
     298.150,  368.300, -4.52019569e+001, +1.19171617e-001, +1.79271693e+000, -6.63318975e-005, +8.22314032e+002, -5.95281760e+005, //err=+7.661e-003
     368.300,  388.360, +8.30338243e-004, +1.56960291e-001, +1.16267852e-008, -1.86290139e-004, +0.00000000e+000, -5.95281760e+005, //err=+5.537e-003
     388.360,  432.020, +2.56304994e+001, +8.07299082e-003, +9.33524492e-004, +2.63503499e-005, +2.38496601e+000, -5.95281760e+005, //err=+4.010e-003
     432.020,  800.000, +9.12159358e+001, +1.57191608e-004, +2.10161223e+006, +3.53489254e-006, -1.43527805e+003, +1.02770107e+004, //err=+2.216e-004
     800.000,  882.117, +2.35021339e+001, +2.83010826e-002, +1.00228920e-004, +0.00000000e+000, +0.00000000e+000, +1.02770107e+004, //err=+9.725e-006
     882.117, 2300.000, +2.02069954e+002, -3.38778563e-003, -5.87172979e+006, +5.36039353e-007, -4.26160599e+003, -1.23437757e+004, //err=+2.034e-004
    2300.000, 3000.000, +2.09178834e+002, -3.32613808e-003, -1.10513674e-001, +3.72482116e-007, -4.62113000e+003, -7.06767264e-005, //err=+6.521e-005
    3000.000, 4000.000, +1.97161987e+002, -6.39927904e-004, -6.74374931e-002, +1.01259132e-007, -4.27061252e+003, -3.27187954e-005, //err=+6.396e-005
    4000.000, 5000.000, +1.91932913e+002, +2.46484681e-004, -4.39802541e-002, +3.32528236e-008, -4.09534043e+003, -1.64732165e-005, //err=+6.691e-005
    5000.000, 6000.000, +1.86432589e+002, +9.60275111e-004, -3.07428941e-002, -8.57001394e-009, -3.88484496e+003, -9.38622648e-006, //err=+9.599e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Cl", 17, "chlorine", 35.453000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Cl2(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:13 2013
 "... further comment...",
      298.150,  +9.18100, +223.07900,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +1.07401616e+002, +2.20949907e-001, +1.50933941e+005, -1.76936296e-004, +1.10290088e+003, -1.37636581e+006, //err=+7.605e-003
     298.150,  800.000, +2.02535818e+002, +4.96175802e-002, +5.55562698e+005, -1.19162394e-005, +9.66527062e+000, +5.04291005e+003, //err=+4.334e-004
     800.000, 2300.000, +2.64045505e+002, +1.43150359e-002, +2.95824956e+006, -1.14484470e-006, -1.23239416e+003, +6.55214612e+003, //err=+3.467e-004
    2300.000, 3000.000, +2.71807202e+002, +1.08049188e-002, -3.18134160e-002, -5.76463188e-007, -1.33473649e+003, -2.03000392e-005, //err=+7.161e-005
    3000.000, 4000.000, +2.81975304e+002, +8.54712652e-003, -2.57739179e-002, -3.50241170e-007, -1.63218429e+003, -1.25047879e-005, //err=+6.665e-005
    4000.000, 5000.000, +2.86029718e+002, +7.85405988e-003, -1.89757402e-002, -2.97171511e-007, -1.76697742e+003, -7.10754138e-006, //err=+8.272e-005
    5000.000, 6000.000, +2.95391819e+002, +6.63330618e-003, -1.68058065e-002, -2.25726472e-007, -2.12367620e+003, -5.13104281e-006, //err=+5.656e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ar", 18, "argon", 39.948000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Ar1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:14 2013
 "... further comment...",
      298.150,  +6.19700, +154.84500,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +7.78697011e+001, +1.53227989e-001, +1.03392600e+005, -1.30331515e-004, +7.20740976e+002, -9.49459538e+005, //err=+5.632e-003
     298.150,  800.000, +1.45781530e+002, +2.73028108e-002, +3.71069399e+005, -6.65515652e-006, -4.59228446e+001, +3.36824222e+003, //err=+2.240e-004
     800.000, 2300.000, +1.79699236e+002, +7.71015447e-003, +1.68732119e+006, -6.29263928e-007, -7.29145122e+002, +3.74726482e+003, //err=+2.347e-004
    2300.000, 3000.000, +1.84952580e+002, +5.56697008e-003, -1.94431509e-002, -2.99443064e-007, -8.13015481e+002, -1.24344636e-005, //err=+3.607e-005
    3000.000, 4000.000, +1.90124734e+002, +4.49274030e-003, -1.52988477e-002, -1.99962291e-007, -9.68829766e+002, -7.42257528e-006, //err=+6.356e-005
    4000.000, 5000.000, +1.95239768e+002, +3.60441876e-003, -1.22187805e-002, -1.30602606e-007, -1.13778483e+003, -4.57665879e-006, //err=+6.703e-005
    5000.000, 6000.000, +1.99943501e+002, +2.93632748e-003, -1.03638107e-002, -8.79168787e-008, -1.30962939e+003, -3.16421330e-006, //err=+9.272e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"K", 19, "potassium", 39.102000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "K1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:15 2013
 "... further comment...",
      298.150,  +7.08200, +64.67000,   // Tref H298(kJ) & S298(J) ref. element 
      336.350,  +2.33400,  +6.94000,   // T(K) H(kJ) S(J) melt 
     1039.540, +79.55600, +76.53100,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -3.70230352e+001, +1.96478342e-001, +1.25213591e+005, -1.61014675e-004, +9.67855668e+002, -1.18505170e+006, //err=+7.176e-003
     298.150,  336.350, +7.67059408e+001, -8.10257536e-002, +4.77588642e-003, +1.36364281e-004, +0.00000000e+000, -1.18505170e+006, //err=+1.915e-002
     336.350,  800.000, +7.31835096e+001, +3.22342637e-002, +5.97322067e+005, -7.47023484e-006, -4.32453904e+002, +5.04867806e+003, //err=+2.134e-004
     800.000, 1039.540, +7.40748097e+001, +2.64803257e-002, -1.64808555e-001, -4.25555491e-006, -3.59253092e+002, +5.04867806e+003, //err=+2.905e-006
    1039.540, 2300.000, +2.76055476e+002, -5.77332214e-003, -9.00349387e+006, +6.97332283e-007, -5.69440528e+003, -1.70369028e+004, //err=+9.090e-005
    2300.000, 3000.000, +2.92493117e+002, -7.57018945e-003, -1.52473530e-001, +7.34900322e-007, -6.37568165e+003, -9.75112812e-005, //err=+7.655e-005
    3000.000, 4000.000, +2.79802638e+002, -4.70614177e-003, -9.48665425e-002, +4.43602810e-007, -6.00761128e+003, -4.60266071e-005, //err=+6.253e-005
    4000.000, 5000.000, +2.84116045e+002, -5.08045152e-003, -6.64579990e-002, +4.46269088e-007, -6.18841650e+003, -2.48924666e-005, //err=+2.870e-004
    5000.000, 6000.000, +2.70628815e+002, -2.79375096e-003, -4.55053874e-002, +2.80556066e-007, -5.75031661e+003, -1.38934178e-005, //err=+5.052e-004
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ca", 20, "calcium", 40.080000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Ca1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:16 2013
 "... further comment...",
      298.150,  +5.73600, +41.58800,   // Tref H298(kJ) & S298(J) ref. element 
     1115.000,  +8.54000,  +7.65900,   // T(K) H(kJ) S(J) melt 
     1773.658, +149.04700, +84.03400,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -5.74314182e+001, +1.91822117e-001, +9.36217833e+004, -1.59503392e-004, +9.49311817e+002, -8.93809103e+005, //err=+6.161e-003
     298.150,  716.000, +2.74213915e+001, +3.42985546e-002, +4.11367981e+005, -6.04534465e-006, -2.58204045e+000, +4.00826471e+003, //err=+1.174e-004
     716.000,  800.000, +3.17286190e+001, +2.49404762e-002, +1.66858656e-004, +0.00000000e+000, +0.00000000e+000, +4.00826471e+003, //err=+5.771e-006
     800.000, 1115.000, +4.00002787e+001, +2.28759288e-002, -7.39573535e-002, -1.21140192e-006, -1.65313380e+002, -1.97225785e-004, //err=+7.707e-005
    1115.000, 1773.658, +7.64114559e+001, +1.79499971e-002, -2.88140188e-001, -1.94414076e-006, -1.16733415e+003, -5.21885745e-004, //err=+1.418e-004
    1773.658, 2300.000, +4.38837378e+002, -3.50367965e-002, -4.70527754e-001, +3.62340270e-006, -1.32104707e+004, -3.92407989e-004, //err=+1.408e-004
    2300.000, 3000.000, +3.90316108e+002, -2.09761393e-002, -2.86213179e-001, +1.78494713e-006, -1.19680059e+004, -1.83041698e-004, //err=+1.338e-004
    3000.000, 4000.000, +3.58571012e+002, -1.39327166e-002, -1.74316325e-001, +1.07963266e-006, -1.10389258e+004, -8.45734310e-005, //err=+1.213e-004
    4000.000, 5000.000, +3.23348636e+002, -8.02507098e-003, -1.05821032e-001, +6.32946685e-007, -9.85381192e+003, -3.96362597e-005, //err=+4.321e-005
    5000.000, 6000.000, +2.77802055e+002, -1.86943824e-003, -6.44744705e-002, +2.58377204e-007, -8.14735661e+003, -1.96849386e-005, //err=+7.785e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

// No JANAF match found for > Sc1(ref)<. $@
{"Sc", 21, "scandium",  44.955900, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1991 p.1307 ref Hu1, 6oct99. SOL-A <1608, SOL-B <1812, LIQ <3101, Monatomic Gas",
   "A->B dH=4.008kJ  dS=2.493J",
    298.150,    +0.00000,  +34.64400,   
	1812.000,  +14.09600,   +7.77900,     
	3101.000,  +314.16000,   +0.00000,
    298.15,    1608.0,      39.48461114,      0.020230891,        689556.272,      -2.08259E-06,     -318.4068639,       +0.00000000e+000,  
    1608.0,     1812.0,      13.73944,         0.033751889,       5246618.429,      -4.28308E-06,        0.0,             +0.00000000e+000, 
    1812.000,   3101.000,  +1.05297000e+002,  +8.80452500e-003,  +9.34303853e+006,  -4.16150000e-007,  -2.56669036e+003,   +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

{"Ti", 22, "titanium", 47.900000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Ti1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:26 2013
 "... further comment...",
      298.150,  +4.83000, +30.75900,   // Tref H298(kJ) & S298(J) ref. element 
     1939.000, +14.14600,  +7.29500,   // T(K) H(kJ) S(J) melt 
     3630.956, +409.98400, +112.91400,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.25433192e+001, +1.74139892e-001, +6.71868981e+004, -1.38098565e-004, +9.13750212e+002, -6.04719378e+005, //err=+4.807e-003
     298.150,  800.000, +1.29108877e+001, +3.89738014e-002, +3.88568820e+005, -9.11932674e-006, +4.60703583e+001, +3.52708615e+003, //err=+3.303e-004
     800.000, 1166.000, +6.29620309e+001, +6.90056098e-003, +1.72020484e+006, +1.29921581e-006, -8.91288513e+002, +4.97547187e+003, //err=+1.493e-008
    1166.000, 1939.000, +6.53457556e+001, +1.06196519e-002, -2.22637447e-001, -4.50620229e-007, -9.96325392e+002, -3.77958601e-004, //err=+1.096e-004
    1939.000, 2300.000, +5.64978255e+001, +1.67220692e-002, -3.38856409e-002, -1.08324350e-006, -1.02300815e+003, -2.68692974e-005, //err=+4.921e-005
    2300.000, 3000.000, +6.34107809e+001, +1.50596644e-002, -2.90544090e-002, -9.10859398e-007, -1.21491030e+003, -1.85811442e-005, //err=+5.214e-005
    3000.000, 3630.956, +7.75226907e+001, +1.18397062e-002, -2.73835585e-002, -5.79878448e-007, -1.62190844e+003, -1.38599406e-005, //err=+8.586e-005
    3630.956, 4000.000, +5.25532518e+002, -1.68208503e-002, -3.19306894e-001, +7.84379927e-007, -2.34309063e+004, -1.39896387e-004, //err=+5.862e-005
    4000.000, 5000.000, +5.29474237e+002, -1.82018838e-002, -2.52275310e-001, +9.42978894e-007, -2.34912985e+004, -9.44920823e-005, //err=+8.610e-005
    5000.000, 6000.000, +4.70606370e+002, -1.02058571e-002, -1.68485585e-001, +4.53685330e-007, -2.12907859e+004, -5.14409559e-005, //err=+7.273e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"V", 23, "vanadium", 50.941500, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "V1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:28 2013
 "... further comment...",
      298.150,  +4.64000, +28.93600,   // Tref H298(kJ) & S298(J) ref. element 
     2190.000, +22.84500, +10.43200,   // T(K) H(kJ) S(J) melt 
     3690.080, +446.97700, +121.13000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.24576564e+001, +1.68667206e-001, +6.17990833e+004, -1.31485215e-004, +8.99839086e+002, -5.43676167e+005, //err=+4.047e-003
     298.150,  800.000, +1.37443131e+001, +3.63685679e-002, +4.08383462e+005, -8.39472904e-006, +8.64582788e+000, +3.70694622e+003, //err=+4.244e-004
     800.000, 2190.000, +5.68107076e+001, +1.07446560e-002, +1.96577757e+006, -3.37270682e-007, -8.44296827e+002, +4.42486015e+003, //err=+2.244e-004
    2190.000, 2300.000, +5.02900000e+000, +3.33645455e-002, +1.18031902e-011, -3.54545455e-006, +0.00000000e+000, +4.42486015e+003, //err=+2.031e-007
    2300.000, 3000.000, +7.03617049e+001, +1.32264923e-002, -3.87606768e-002, -7.51432429e-007, -1.62077795e+003, -2.47885863e-005, //err=+6.197e-005
    3000.000, 3690.080, +8.02929542e+001, +1.10153991e-002, -3.18641024e-002, -5.30729824e-007, -1.91021504e+003, -1.60040893e-005, //err=+7.616e-005
    3690.080, 4000.000, +7.26091729e+002, -4.73783650e-002, -4.16961955e-001, +3.03804576e-006, -3.10024648e+004, -1.81052639e-004, //err=+4.877e-005
    4000.000, 5000.000, +5.79520360e+002, -2.25336252e-002, -2.80265132e-001, +1.14058443e-006, -2.60976465e+004, -1.04975933e-004, //err=+1.062e-004
    5000.000, 6000.000, +5.16281382e+002, -1.40079622e-002, -1.87746809e-001, +6.22679798e-007, -2.37247424e+004, -5.73216714e-005, //err=+4.558e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Cr", 24, "chromium", 51.996000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Cr1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:30 2013
 "... further comment...",
      298.150,  +4.05700, +23.61800,   // Tref H298(kJ) & S298(J) ref. element 
     2130.000, +20.50200,  +9.62500,   // T(K) H(kJ) S(J) melt 
     2952.078, +339.53700, +115.01600,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.03699130e+001, +1.50332407e-001, +4.70607366e+004, -1.11741712e-004, +8.38827746e+002, -3.75489722e+005, //err=+2.937e-003
     298.150,  311.500, +3.26526074e+001, -6.09547871e-002, +2.13271151e-003, +1.02809208e-004, +0.00000000e+000, -3.75489722e+005, //err=+6.628e-003
     311.500,  800.000, +6.49463678e+000, +3.61777485e-002, +3.53257741e+005, -7.86545664e-006, +5.29421224e+001, +3.06484394e+003, //err=+2.040e-004
     800.000, 2130.000, +4.62157264e+001, +1.13446829e-002, +1.52329488e+006, +9.25087390e-008, -7.04387501e+002, +3.46216643e+003, //err=+7.876e-005
    2130.000, 2300.000, -5.82361345e+000, +3.84342017e-002, -7.17015345e-006, -4.44537815e-006, +0.00000000e+000, +3.46216643e+003, //err=+1.665e-007
    2300.000, 2952.078, +9.09749042e+001, +9.41039335e-003, -5.86809433e-002, -5.30026158e-007, -2.43417784e+003, -3.77147871e-005, //err=+7.614e-005
    2952.078, 3000.000, -8.43613109e+001, +5.20637703e-002, -2.85793988e-005, +0.00000000e+000, +0.00000000e+000, -3.77147871e-005, //err=+2.842e-014
    3000.000, 4000.000, +5.44770037e+002, -2.70252067e-002, -3.52431850e-001, +1.73482476e-006, -2.23184434e+004, -1.70990129e-004, //err=+2.159e-004
    4000.000, 5000.000, +4.83617417e+002, -1.65054663e-002, -2.17861932e-001, +9.19192046e-007, -2.02868037e+004, -8.16022292e-005, //err=+8.110e-005
    5000.000, 6000.000, +4.32812461e+002, -9.86963693e-003, -1.45181593e-001, +5.26283719e-007, -1.83459624e+004, -4.43259282e-005, //err=+1.622e-004
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Mn", 25, "manganese", 54.938000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Mn1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:32 2013
 "... further comment...",
      298.150,  +4.99400, +32.01000,   // Tref H298(kJ) & S298(J) ref. element 
     1519.000, +12.05800,  +7.93800,   // T(K) H(kJ) S(J) melt 
     2334.526, +225.98000, +96.79900,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.27498732e+001, +1.75582585e-001, +7.16461135e+004, -1.37433982e-004, +9.29631554e+002, -6.58781139e+005, //err=+5.326e-003
     298.150,  800.000, +1.15504427e+001, +4.14136669e-002, +3.81107661e+005, -8.73244865e-006, +7.94506246e+001, +3.45936015e+003, //err=+5.590e-004
     800.000,  980.000, +2.06440000e+001, +3.02841667e-002, +1.57647285e-004, -3.70833333e-006, +0.00000000e+000, +3.45936015e+003, //err=+2.439e-006
     980.000, 1361.000, +2.89381710e+001, +2.91976687e-002, -7.31229845e-002, -3.82265378e-006, -2.22880405e+002, -1.59153829e-004, //err=+5.018e-005
    1361.000, 1412.000, +1.62307727e+001, +3.55539816e-002, +5.03589907e-005, -4.90620265e-006, +8.16068727e-001, -1.59153829e-004, //err=+1.523e-013
    1412.000, 1519.000, +1.61017986e+001, +3.48005275e-002, +4.43873502e-005, -4.30750352e-006, +7.85944172e-001, -1.59153829e-004, //err=+2.207e-012
    1519.000, 2300.000, +7.36075142e+001, +1.86936004e-002, -2.46857149e-001, -1.55178151e-006, -1.53472385e+003, -3.35602010e-004, //err=+1.300e-004
    2300.000, 2334.526, +3.40249296e+001, +1.84209002e-002, +1.90118338e-005, +0.00000000e+000, +0.00000000e+000, -3.35602010e-004, //err=+2.721e-014
    2334.526, 3000.000, +5.25235300e+002, -3.49436229e-002, -4.37882997e-001, +2.76649346e-006, -1.84428998e+004, -2.78585687e-004, //err=+1.143e-004
    3000.000, 4000.000, +4.63625541e+002, -2.12127832e-002, -2.62819999e-001, +1.38500981e-006, -1.66435958e+004, -1.27512951e-004, //err=+1.004e-004
    4000.000, 5000.000, +4.19857359e+002, -1.37611848e-002, -1.63030370e-001, +8.12269903e-007, -1.51810143e+004, -6.10645536e-005, //err=+8.023e-005
    5000.000, 6000.000, +4.20715393e+002, -1.32690380e-002, -1.21098401e-001, +7.48290651e-007, -1.53026748e+004, -3.69729996e-005, //err=+4.828e-004
},
{"Fe", 26, "iron", 55.847000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Fe1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:34 2013
 "... further comment...",
      298.150,  +4.50700, +27.32100,   // Tref H298(kJ) & S298(J) ref. element 
     1809.000, +13.80700,  +7.63300,   // T(K) H(kJ) S(J) melt 
     3133.345, +349.58500, +111.56900,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.29706716e+001, +1.64175631e-001, +5.71890616e+004, -1.25076288e-004, +8.94961805e+002, -4.87523148e+005, //err=+3.860e-003
     298.150,  800.000, +1.08185355e+001, +3.53873148e-002, +3.79513541e+005, -5.55026708e-006, +3.75699480e+001, +3.44489031e+003, //err=+3.014e-004
     800.000, 1042.000, +6.86632015e+001, -1.31514103e-002, -3.68352956e-001, +1.23836360e-005, -8.08070309e+002, +3.44489031e+003, //err=+1.980e-006
    1042.000, 1184.000, +1.35741290e+001, +3.20636299e-002, +6.66706329e-005, -3.34892448e-006, +7.65367992e-001, +3.44489031e+003, //err=+1.164e-006
    1184.000, 1665.000, +5.93031316e+001, +1.51731208e-002, -2.42535018e-001, -1.13907828e-006, -9.91204332e+002, -4.34986417e-004, //err=+2.177e-005
    1665.000, 1809.000, +1.26419717e+002, -1.19612211e-002, -1.09640747e-001, +3.86860714e-006, -2.45283208e+003, -1.06031335e-004, //err=+1.300e-011
    1809.000, 2300.000, +6.62244224e+001, +1.76620827e-002, -5.06573665e-002, -1.35693820e-006, -1.44451112e+003, -4.17921438e-005, //err=+1.068e-004
    2300.000, 3000.000, +8.08259574e+001, +1.34176699e-002, -4.34632946e-002, -8.01847556e-007, -1.81741795e+003, -2.77960479e-005, //err=+3.812e-005
    3000.000, 3133.345, +2.00754163e+001, +2.62714044e-002, +3.65360331e-012, -2.02318105e-006, +0.00000000e+000, -2.77960479e-005, //err=+1.768e-004
    3133.345, 4000.000, +5.74029731e+002, -2.86657615e-002, -3.59774249e-001, +1.75525067e-006, -2.34492022e+004, -1.71042222e-004, //err=+1.355e-004
    4000.000, 5000.000, +5.07053188e+002, -1.73532678e-002, -2.27704458e-001, +8.93733639e-007, -2.12033171e+004, -8.52888396e-005, //err=+8.500e-005
    5000.000, 6000.000, +4.62073654e+002, -1.12608979e-002, -1.54465416e-001, +5.21709684e-007, -1.95191184e+004, -4.71604062e-005, //err=+7.851e-005
},
{"Co", 27, "cobalt", 58.933200, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Co1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:36 2013
 "... further comment...",
      298.150,  +4.77100, +30.06700,   // Tref H298(kJ) & S298(J) ref. element 
     1768.000, +16.19200,  +9.15900,   // T(K) H(kJ) S(J) melt 
     3184.943, +375.02800, +117.75100,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.43958599e+001, +1.77150399e-001, +6.38855048e+004, -1.41887742e-004, +9.24718164e+002, -5.62746111e+005, //err=+4.695e-003
     298.150,  700.100, +1.01966026e+001, +3.94082014e-002, +3.43912224e+005, -8.62671362e-006, +8.66655985e+001, +3.28934981e+003, //err=+9.003e-005
     700.100,  800.000, +2.10031091e+001, +2.36136136e-002, +1.13168684e-004, +0.00000000e+000, +0.00000000e+000, +3.28934981e+003, //err=+5.001e-006
     800.000, 1394.000, +8.40912635e+001, -2.40624866e-003, +3.05291100e+006, +4.05655996e-006, -1.40399180e+003, +8.21240227e+003, //err=+9.946e-005
    1394.000, 1768.000, +1.72164599e+001, +3.12450472e-002, -3.34612235e-003, -3.99600401e-006, -1.56815363e+001, -5.35596866e-006, //err=+6.351e-005
    1768.000, 2300.000, +8.37718118e+001, +1.31887507e-002, -6.68677567e-002, -9.45690247e-007, -1.87278507e+003, -5.58619279e-005, //err=+8.597e-005
    2300.000, 3000.000, +9.41687964e+001, +1.02667636e-002, -5.12489515e-002, -5.75660432e-007, -2.14297524e+003, -3.27752032e-005, //err=+5.880e-005
    3000.000, 3184.943, +2.20915094e+001, +2.57210853e-002, +3.47737679e-012, -2.06575168e-006, +0.00000000e+000, -3.27752032e-005, //err=+3.105e-011
    3184.943, 4000.000, +5.81652924e+002, -2.77146438e-002, -3.65041502e-001, +1.61035170e-006, -2.40787601e+004, -1.72101533e-004, //err=+1.086e-004
    4000.000, 5000.000, +5.24068935e+002, -1.80803625e-002, -2.37752609e-001, +8.83865460e-007, -2.21389779e+004, -8.90524687e-005, //err=+9.785e-005
    5000.000, 6000.000, +4.68188054e+002, -1.05992568e-002, -1.58536831e-001, +4.31891126e-007, -2.00336054e+004, -4.84034652e-005, //err=+4.850e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ni", 28, "nickel", 58.710000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Ni1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:25:38 2013
 "... further comment...",
      298.150,  +4.78600, +29.87000,   // Tref H298(kJ) & S298(J) ref. element 
     1728.000, +17.15500,  +9.92700,   // T(K) H(kJ) S(J) melt 
     3156.584, +377.55200, +119.60800,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.41565663e+001, +1.73610257e-001, +6.39763629e+004, -1.35600688e-004, +9.25748338e+002, -5.63373101e+005, //err=+4.626e-003
     298.150,  631.000, +1.47388251e+001, +3.40055485e-002, +4.04484508e+005, -3.94475072e-006, +1.36957284e+001, +3.80006261e+003, //err=+1.404e-004
     631.000,  800.000, +1.81858324e+001, +3.13293774e-002, +2.20876040e-004, -4.43958494e-006, +0.00000000e+000, +3.80006261e+003, //err=+6.302e-006
     800.000, 1728.000, +5.93282479e+001, +1.27478996e-002, +1.87257113e+006, -6.90667405e-007, -8.93849684e+002, +4.61753221e+003, //err=+8.938e-005
    1728.000, 2300.000, +7.70209277e+001, +1.39186665e-002, -2.37784949e-001, -1.07703077e-006, -1.63938505e+003, -3.00665830e-004, //err=+1.053e-004
    2300.000, 3000.000, +9.02371449e+001, +1.00614349e-002, -4.72755811e-002, -5.68187486e-007, -1.97682873e+003, -3.02341166e-005, //err=+2.667e-005
    3000.000, 3156.584, +2.50032412e+001, +2.35008418e-002, +3.22737710e-012, -1.80997406e-006, +0.00000000e+000, -3.02341166e-005, //err=+2.632e-011
    3156.584, 4000.000, +5.91981651e+002, -2.97757152e-002, -3.72071337e-001, +1.73342150e-006, -2.43899715e+004, -1.76180981e-004, //err=+7.454e-005
    4000.000, 5000.000, +5.23902977e+002, -1.83313740e-002, -2.37349864e-001, +8.65726109e-007, -2.21014751e+004, -8.89016166e-005, //err=+9.050e-005
    5000.000, 6000.000, +4.79304055e+002, -1.23140903e-002, -1.61663645e-001, +4.99970839e-007, -2.04287272e+004, -4.93581243e-005, //err=+9.266e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

// ==========================================================================================================

{"Cu", 29, "copper", 63.546000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Cu1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:26 2013
 "... further comment...",
      298.150,  +5.00700, +33.16400,   // Tref H298(kJ) & S298(J) ref. element 
     1358.000, +13.13800,  +9.67400,   // T(K) H(kJ) S(J) melt 
     2843.261, +300.67700, +105.75100,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.13332951e+001, +1.80994918e-001, +7.38864233e+004, -1.49053340e-004, +9.14638302e+002, -6.85866711e+005, //err=+5.709e-003
     298.150,  800.000, +2.01608843e+001, +3.38186300e-002, +4.15601980e+005, -7.61141121e-006, -1.86224878e+001, +3.77246971e+003, //err=+3.436e-004
     800.000, 1358.000, +6.54691304e+001, +7.55098798e-003, +2.05008926e+006, +3.50608885e-007, -9.22111731e+002, +5.57679217e+003, //err=+4.281e-005
    1358.000, 2300.000, +7.30476572e+001, +1.29216783e-002, -2.34350383e-001, -1.09586291e-006, -1.33091341e+003, -3.39724176e-004, //err=+2.466e-004
    2300.000, 2843.261, +8.64002927e+001, +8.79218798e-003, -4.12108563e-002, -5.18583816e-007, -1.66219061e+003, -2.69616566e-005, //err=+5.542e-005
    2843.261, 3000.000, -1.78715459e+002, +1.30717875e-001, +2.10258253e-011, -1.44623517e-005, +0.00000000e+000, -2.69616566e-005, //err=+4.732e-011
    3000.000, 4000.000, +4.92840538e+002, -2.38400302e-002, -3.04301466e-001, +1.53185115e-006, -1.92704917e+004, -1.47638605e-004, //err=+1.925e-004
    4000.000, 5000.000, +4.24675872e+002, -1.22618218e-002, -1.82471296e-001, +6.45230354e-007, -1.69913088e+004, -6.83463346e-005, //err=+7.384e-005
    5000.000, 6000.000, +3.78346120e+002, -6.02563842e-003, -1.20687994e-001, +2.66608728e-007, -1.52508136e+004, -3.68476971e-005, //err=+5.429e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Zn", 30, "zinc", 65.380000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Zn1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:27 2013
 "... further comment...",
      298.150,  +5.66900, +41.71700,   // Tref H298(kJ) & S298(J) ref. element 
      692.730,  +7.32200, +10.57000,   // T(K) H(kJ) S(J) melt 
     1180.173, +115.31100, +97.70600,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -5.50140194e+001, +1.87773761e-001, +9.33939168e+004, -1.56531829e-004, +9.26118721e+002, -8.93697324e+005, //err=+6.375e-003
     298.150,  692.730, +2.65518219e+001, +3.59115588e-002, +4.03724627e+005, -7.71025078e-006, +1.03891658e+001, +3.87024319e+003, //err=+1.268e-004
     692.730,  800.000, +1.29154862e+001, +6.62413763e-002, +1.46455026e-004, -2.05009175e-005, +0.00000000e+000, +3.87024319e+003, //err=+5.336e-006
     800.000, 1180.173, +5.94296510e+001, +2.51859766e-002, +5.56260612e+004, -4.06819117e-006, -6.86564082e+002, +1.60192309e+002, //err=+4.429e-011
    1180.173, 2300.000, +3.10087763e+002, -9.61078755e-003, -1.52368660e+007, +9.79175704e-007, -7.75112660e+003, -2.66762143e+004, //err=+7.764e-005
    2300.000, 3000.000, +3.37990634e+002, -1.27622023e-002, -2.12903618e-001, +1.06879631e-006, -8.90256618e+003, -1.36158090e-004, //err=+1.162e-004
    3000.000, 4000.000, +3.08932288e+002, -6.28038192e-003, -1.27184465e-001, +4.15934230e-007, -8.05420760e+003, -6.17063640e-005, //err=+1.450e-004
    4000.000, 5000.000, +2.91873301e+002, -3.37245491e-003, -8.03827539e-002, +1.92669278e-007, -7.48505775e+003, -3.01081140e-005, //err=+4.398e-005
    5000.000, 6000.000, +2.79962683e+002, -1.80640149e-003, -5.56504473e-002, +9.97620706e-008, -7.03230342e+003, -1.69908435e-005, //err=+7.344e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ga", 31, "gallium", 69.735000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Ga1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:30 2013
 "... further comment...",
      298.150,  +5.56100, +40.83800,   // Tref H298(kJ) & S298(J) ref. element 
      302.920,  +5.59000, +18.45300,   // T(K) H(kJ) S(J) melt 
     2476.570, +258.71000, +104.46400,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -5.48308546e+001, +1.83191978e-001, +8.94957121e+004, -1.49944177e-004, +9.21988059e+002, -8.46235940e+005, //err=+6.066e-003
     298.150,  302.920, +4.98061666e+001, -6.05104746e-002, +3.31286580e-003, +1.02066397e-004, +0.00000000e+000, -8.46235940e+005, //err=+1.552e-002
     302.920,  800.000, +6.96780267e+001, +2.43126354e-002, +3.32201102e+005, -5.21245508e-006, -6.84746710e+002, +3.22781078e+003, //err=+1.303e-004
     800.000, 2300.000, +9.75661459e+001, +8.95355994e-003, +1.49853564e+006, -7.16785346e-007, -1.25890270e+003, +3.32800299e+003, //err=+2.254e-004
    2300.000, 2476.570, +5.13867762e+001, +2.10515855e-002, +5.39895038e-005, -2.15565648e-006, +0.00000000e+000, +3.32800299e+003, //err=+1.196e-007
    2476.570, 3000.000, +5.15957263e+002, -3.28134102e-002, -4.05507613e-001, +2.55837274e-006, -1.79195851e+004, -2.49507681e-004, //err=+2.117e-005
    3000.000, 4000.000, +4.50278495e+002, -1.82419082e-002, -2.52611238e-001, +1.09892566e-006, -1.59971058e+004, -1.22559944e-004, //err=+9.302e-005
    4000.000, 5000.000, +4.05516912e+002, -1.06277847e-002, -1.55730020e-001, +5.14743491e-007, -1.45012224e+004, -5.83301388e-005, //err=+9.033e-005
    5000.000, 6000.000, +3.71107285e+002, -6.03364751e-003, -1.04483556e-001, +2.37982012e-007, -1.32031295e+004, -3.19002600e-005, //err=+6.015e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
// No JANAF match found for > Ge1(ref)<. $@
// No JANAF match found for > As1(ref)<. $@
// No JANAF match found for > Se1(ref)<. $@
{"Ge", 32, "germanium",  72.590000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg 30-Sep-97, Barin 1991 p.618 ref Hu1, SOL<1210.4, LIQ<3104, Monatomic Gas",
   "... further comment",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +31.08700,   1210.400,  +36.94500,  +30.52300,     3104.000,  +331.00000,   +0.00000,
     298.150,   1210.400,  +2.99504767e+001,  +2.32653210e-002,  +5.56763796e+005,  -3.72721000e-006,  -2.02540851e+002,  +0.00000000e+000,
    1210.400,   3104.000,  +1.31925533e+002,  +3.77809600e-003,  -1.46236933e+006,  -1.62462000e-007,  -3.06334627e+003,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"As", 33, "arsenic",  74.921600, 1,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg. 5-Oct-99. Barin 1991 p.77+79 ref Hu1. Ref states: As(s)->As2(g)@1407 K. Data to 2000 only",
   "Tm(1090.15 at 28atm)+Sublime 886.15=CRC#52 Barin: Tmelt=1081K, Tsubl=1407, dH=34.8kJ.",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    1090.15,   +0.00000,   +0.00000,      1407.0,   +34.8,   +0.00000,
	/* Add data for 2000-3000 the same as lower T, but Barin stops at 2000 K */										
       298.15,    1407.0,      37.7098588,      0.021820668,       629611.1343,     -2.96524E-06,       -264.6211299,     +0.00000000e+000,
       1407.0,    2000.0,     473.0711698,     -0.009993912,    -29087797.46,        8.94475E-07,     -12547.59569,		  +0.00000000e+000,
       2000.0,    3000.0,     473.0711698,     -0.009993912,    -29087797.46,        8.94475E-07,     -12547.59569,		  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Se", 34, "selenium",  78.960000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1989 regress 4oct99. S<493. L <1007. Std state Se2(g) >958 K.",
   "Tm=490.15, Tb=658.05 in CRC#52. Add 2000-3000 clone of gef(gas)",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    490.15,   +0.00000,   +0.00000,      658.05,   +0.00000,   +0.00000,
       298.15,     493.0,      30.21817656,       0.025934152,      361413.5132,        2.7208E-06,          0.0,          +0.00000000e+000,
       493.0,      958.0,      68.76199024,       0.025354476,      849039.7498,       -4.0629E-06,       -857.4081856,	   +0.00000000e+000,
       958.0,     2000.0,     444.7690569,       -0.007996014,   -12063899.33,          1.04591E-06,     -9455.156985,	   +0.00000000e+000,
      2000.0,     3000.0,     444.7690569,       -0.007996014,   -12063899.33,          1.04591E-06,     -9455.156985,	   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Br", 35, "bromine", 79.904000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Br2(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:34 2013
 "... further comment...",
      298.150, +24.50900, +152.20600,   // Tref H298(kJ) & S298(J) ref. element 
      265.900, +10.57100, +39.75800,   // T(K) H(kJ) S(J) melt 
      332.503, +29.56300, +88.91200,   // T(K) H(kJ) S(J) vapor
      25.000,  265.900, -2.20738078e+002, +5.96504114e-001, +3.70958280e+005, -5.35018395e-004, +4.03729941e+003, -3.30891390e+006, //err=+1.276e-002
     265.900,  298.150, +1.57004135e+002, -1.60930227e-002, +5.96725164e-003, +0.00000000e+000, +0.00000000e+000, -3.30891390e+006, //err=+9.282e-002
     298.150,  332.503, +1.83594778e+002, -2.10982154e-001, +1.15110359e-002, +3.54531867e-004, +0.00000000e+000, -3.30891390e+006, //err=+5.409e-002
     332.503,  800.000, +3.21223961e+002, +8.33532159e-003, -6.11967068e+005, -9.00658399e-008, -3.02351143e+003, -4.68386662e+003, //err=+7.654e-005
     800.000, 2300.000, +3.23595717e+002, +8.47664867e-003, -2.99370396e+005, -5.10522872e-007, -3.09998259e+003, -6.63067120e+002, //err=+1.703e-004
    2300.000, 3000.000, +3.31114299e+002, +6.28872540e-003, -7.85892803e-002, -2.13519114e-007, -3.29722468e+003, -5.01475690e-005, //err=+4.297e-005
    3000.000, 4000.000, +3.29082188e+002, +6.78582253e-003, -5.11755859e-002, -2.67876389e-007, -3.24079511e+003, -2.48289705e-005, //err=+8.135e-005
    4000.000, 5000.000, +3.29822313e+002, +6.65863576e-003, -3.50681478e-002, -2.57946616e-007, -3.26546552e+003, -1.31351035e-005, //err=+6.404e-005
    5000.000, 6000.000, +3.36071002e+002, +5.77492151e-003, -2.76513070e-002, -2.01775245e-007, -3.49417462e+003, -8.44232261e-006, //err=+3.628e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Kr", 36, "krypton", 83.800000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Kr1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:35 2013
 "... further comment...",
      298.150,  +6.19700, +164.08400,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +8.70483974e+001, +1.53419633e-001, +1.03313379e+005, -1.30622991e-004, +7.21258084e+002, -9.48209118e+005, //err=+5.620e-003
     298.150,  800.000, +1.55301657e+002, +2.70316061e-002, +3.73812001e+005, -6.53015261e-006, -5.00965869e+001, +3.39313717e+003, //err=+2.878e-004
     800.000, 2300.000, +1.88662354e+002, +7.79531560e-003, +1.66097635e+006, -6.41757900e-007, -7.21852494e+002, +3.68875723e+003, //err=+2.283e-004
    2300.000, 3000.000, +1.90758891e+002, +6.45307493e-003, -1.72211026e-002, -4.01886517e-007, -7.20100519e+002, -1.10133987e-005, //err=+6.886e-005
    3000.000, 4000.000, +2.00592557e+002, +4.26337703e-003, -1.59165491e-002, -1.80697341e-007, -1.00794693e+003, -7.72226679e-006, //err=+6.509e-005
    4000.000, 5000.000, +2.04982099e+002, +3.53373803e-003, -1.24159538e-002, -1.26187317e-007, -1.15614515e+003, -4.65051189e-006, //err=+5.919e-005
    5000.000, 6000.000, +2.13401419e+002, +2.42005086e-003, -1.16765553e-002, -5.95535072e-008, -1.47551517e+003, -3.56501219e-006, //err=+6.662e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Rb", 37, "rubidium", 85.467800, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Rb1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:36 2013
 "... further comment...",
      298.150,  +7.49000, +76.77800,   // Tref H298(kJ) & S298(J) ref. element 
      312.650,  +2.19300,  +7.01600,   // T(K) H(kJ) S(J) melt 
      970.385, +71.78700, +73.97800,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -2.54381577e+001, +1.96414625e-001, +1.30825326e+005, -1.59454198e-004, +9.73748621e+002, -1.21899905e+006, //err=+7.336e-003
     298.150,  312.650, +8.98621399e+001, -8.80354278e-002, +5.85544414e-003, +1.48083204e-004, +0.00000000e+000, -1.21899905e+006, //err=+2.141e-002
     312.650,  800.000, +8.13378126e+001, +3.53598676e-002, +5.45563915e+005, -8.37426507e-006, -3.59694468e+002, +4.60654592e+003, //err=+3.382e-004
     800.000,  970.385, +6.38780689e+001, +4.35081705e-002, +4.90653028e-004, -9.81657091e-006, +0.00000000e+000, +4.60654592e+003, //err=+3.276e-006
     970.385, 2300.000, +2.79971791e+002, -5.23838458e-003, -7.71966440e+006, +6.74779879e-007, -5.31038189e+003, -1.52532242e+004, //err=+1.589e-004
    2300.000, 3000.000, +2.94567828e+002, -6.83093003e-003, -1.41369471e-001, +7.00931020e-007, -5.91136535e+003, -9.04099108e-005, //err=+7.844e-005
    3000.000, 4000.000, +2.84277855e+002, -4.47280117e-003, -8.86699880e-002, +4.57412862e-007, -5.61520222e+003, -4.30202112e-005, //err=+5.026e-005
    4000.000, 5000.000, +2.84698145e+002, -4.25737048e-003, -6.07618490e-002, +4.19609019e-007, -5.65800407e+003, -2.27589202e-005, //err=+5.241e-004
    5000.000, 6000.000, +3.09836837e+002, -6.73642293e-003, -5.32911878e-002, +5.18506499e-007, -6.73417412e+003, -1.62705292e-005, //err=+5.590e-004
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Sr", 38, "strontium", 87.620000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Sr1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:38 2013
 "... further comment...",
      298.150,  +6.56800, +55.69400,   // Tref H298(kJ) & S298(J) ref. element 
     1050.000,  +7.43100,  +7.07700,   // T(K) H(kJ) S(J) melt 
     1685.492, +137.18500, +81.39100,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.43246208e+001, +2.57718408e-001, +9.12393399e+004, -2.52865120e-004, +1.11462624e+003, -7.34887305e+005, //err=+1.373e-002
     298.150,  800.000, +4.07590599e+001, +3.69603847e-002, +4.37783764e+005, -7.79995581e-006, -5.45690957e+000, +4.24582221e+003, //err=+2.860e-004
     800.000,  820.000, +4.75070000e+001, +2.29000000e-002, +2.17301694e-004, +0.00000000e+000, +0.00000000e+000, +4.24582221e+003, //err=+4.563e-006
     820.000, 1050.000, +4.73957565e+001, +3.11851587e-002, -3.95972801e-002, -5.46276855e-006, -8.61767044e+001, -1.06484638e-004, //err=+1.188e-011
    1050.000, 1685.492, +9.66309492e+001, +1.55445131e-002, +3.02114724e+006, -1.39282804e-006, -1.38361633e+003, +6.41944447e+003, //err=+4.338e-005
    1685.492, 2300.000, +4.36246570e+002, -3.43687172e-002, -1.83326755e+000, +3.69472877e-006, -1.24222696e+004, -2.34665886e-003, //err=+2.069e-004
    2300.000, 3000.000, +3.85745246e+002, -1.94777796e-002, -2.66401769e-001, +1.71105860e-006, -1.11395917e+004, -1.70371722e-004, //err=+1.329e-004
    3000.000, 4000.000, +3.59939298e+002, -1.37695266e-002, -1.63965784e-001, +1.14174614e-006, -1.03834573e+004, -7.95516364e-005, //err=+1.061e-004
    4000.000, 5000.000, +3.14786710e+002, -6.19718865e-003, -9.51890541e-002, +5.68929377e-007, -8.86378648e+003, -3.56539526e-005, //err=+9.241e-005
    5000.000, 6000.000, +2.30572837e+002, +4.88847819e-003, -4.48348401e-002, -8.88219576e-008, -5.66558248e+003, -1.36886905e-005, //err=+2.231e-004
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

// No JANAF match found for > Y1(ref)<. $@
{"Y", 39, "yttrium",  88.905900, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1991 p.1670 ref Hu1. Reg A+B 23sep97. SOL-A<1752 SOL-B<1799 LIQ <3607, Monatomic Gas",
   "A->B dH=4.992kJ  dS=2.849J",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +44.43400,   1799.000,  +11.39700,   +6.33500,     3607.000,  +363.34000,   +0.00000,
      25.000,  298.150, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
     298.150,   1799.000,  +5.04883001e+001,  +2.06790040e-002,  +7.45734244e+005,  -2.24294000e-006,  -3.52278901e+002,  +0.00000000e+000, 
    1799.000,   3607.000,  +1.15389506e+002,  +8.11407500e-003,  +1.03902939e+007,  -3.59045000e-007,  -2.52879740e+003,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

{"Zr", 40, "zirconium", 91.220000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Zr1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:41 2013
 "... further comment...",
      298.150,  +5.49700, +38.86900,   // Tref H298(kJ) & S298(J) ref. element 
     2125.000, +20.92000,  +9.84500,   // T(K) H(kJ) S(J) melt 
     4702.633, +561.29400, +119.35700,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -5.84570329e+001, +1.88792436e-001, +8.81382503e+004, -1.57605736e-004, +9.33786153e+002, -8.41747317e+005, //err=+6.251e-003
     298.150,  800.000, +2.71073959e+001, +3.30645180e-002, +4.40630389e+005, -6.99518249e-006, -4.19767854e+001, +3.99965573e+003, //err=+3.355e-004
     800.000, 1135.000, +3.25040329e+001, +2.49484184e-002, -2.69825936e-002, -3.18251448e-006, -6.04995924e+001, -7.13401119e-005, //err=+7.191e-005
    1135.000, 2125.000, +9.26571646e+001, +4.96139611e-003, +2.89276038e+006, +1.84000325e-007, -1.54453585e+003, +5.33390229e+003, //err=+5.257e-005
    2125.000, 2300.000, +1.78952857e+001, +3.24757143e-002, +2.20690940e-005, -3.48571429e-006, +0.00000000e+000, +5.33390229e+003, //err=+2.575e-007
    2300.000, 3000.000, +8.63488288e+001, +1.18790829e-002, -4.10989867e-002, -6.96854286e-007, -1.71855440e+003, -2.62840039e-005, //err=+6.010e-005
    3000.000, 4000.000, +1.01396718e+002, +8.59178625e-003, -3.41480891e-002, -3.72501521e-007, -2.16249523e+003, -1.65677028e-005, //err=+6.236e-005
    4000.000, 4702.633, +1.04759253e+002, +7.91239329e-003, -2.53238748e-002, -3.12761887e-007, -2.26372817e+003, -9.73608067e-006, //err=+5.628e-005
    4702.633, 5000.000, +6.35874962e+002, -2.46774804e-002, -2.89026195e-001, +1.20078009e-006, -3.04709326e+004, -9.73608067e-006, //err=+1.590e-009
    5000.000, 6000.000, +5.56174118e+002, -1.39741829e-002, -2.17409873e-001, +5.52351079e-007, -2.74731339e+004, -6.63782107e-005, //err=+5.889e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Nb", 41, "niobium", 92.906400, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Nb1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:44 2013
 "... further comment...",
      298.150,  +5.24100, +36.46400,   // Tref H298(kJ) & S298(J) ref. element 
     2750.000, +26.90300,  +9.78300,   // T(K) H(kJ) S(J) melt 
     5130.824, +690.45900, +134.57100,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -5.87279463e+001, +1.83568159e-001, +8.17013443e+004, -1.52232949e-004, +9.16793769e+002, -7.72814644e+005, //err=+6.129e-003
     298.150,  800.000, +2.42816622e+001, +3.33381060e-002, +4.28882421e+005, -7.50761986e-006, -3.30600575e+001, +3.89301795e+003, //err=+3.068e-004
     800.000, 2300.000, +6.73915830e+001, +9.49850654e-003, +2.25256126e+006, -4.62359854e-007, -9.21043732e+002, +5.00257072e+003, //err=+3.541e-004
    2300.000, 2750.000, +8.50380895e+001, +3.54383707e-003, -3.31693572e-002, +3.84523782e-007, -1.30485148e+003, -2.20493216e-005, //err=+4.897e-005
    2750.000, 3000.000, +7.20502274e+001, +1.46153689e-002, -3.33796761e-002, -1.17117919e-006, -1.60344252e+003, -2.20493216e-005, //err=+4.659e-011
    3000.000, 4000.000, +1.12652333e+002, +5.29741631e-003, -4.37562363e-002, -2.08144230e-007, -2.77095014e+003, -2.12293085e-005, //err=+5.560e-005
    4000.000, 5000.000, +1.22208627e+002, +3.77468628e-003, -3.33011275e-002, -9.86541620e-008, -3.10092465e+003, -1.24732495e-005, //err=+4.046e-005
    5000.000, 5130.824, +4.00746249e+001, +1.47095093e-002, +4.53300590e-013, -7.54406865e-007, +0.00000000e+000, -1.24732495e-005, //err=+1.768e-004
    5130.824, 6000.000, +6.35812903e+002, -1.96815460e-002, -2.56347149e-001, +7.86199589e-007, -3.29382870e+004, -7.73688230e-005, //err=+1.048e-004
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Mo", 42, "molybdenum", 95.940000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Mo1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:46 2013
 "... further comment...",
      298.150,  +4.58500, +28.60500,   // Tref H298(kJ) & S298(J) ref. element 
     2896.000, +35.98200, +12.42400,   // T(K) H(kJ) S(J) melt 
     4951.969, +590.63100, +119.27200,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.27535633e+001, +1.71687283e-001, +6.12144000e+004, -1.37939502e-004, +8.93688339e+002, -5.41893868e+005, //err=+4.763e-003
     298.150,  800.000, +1.40993122e+001, +3.46640861e-002, +3.89366018e+005, -7.88905207e-006, +8.50050879e+000, +3.53432257e+003, //err=+3.320e-004
     800.000, 2300.000, +5.92984121e+001, +9.19400307e-003, +2.20128598e+006, -2.72691195e-007, -9.11501646e+002, +4.88869669e+003, //err=+3.159e-004
    2300.000, 2896.000, +7.77194618e+001, +3.11027427e-003, -3.22708116e-002, +5.80163278e-007, -1.32020837e+003, -2.09236824e-005, //err=+5.819e-005
    2896.000, 3000.000, -6.06153843e-001, +3.17192308e-002, +4.95530052e-012, -2.88461538e-006, +0.00000000e+000, -2.09236824e-005, //err=+6.088e-012
    3000.000, 4000.000, +1.12624075e+002, +5.90131718e-003, -5.15591876e-002, -2.36235276e-007, -3.26508745e+003, -2.50150834e-005, //err=+4.589e-005
    4000.000, 4951.969, +1.17560681e+002, +5.03752352e-003, -3.69192103e-002, -1.68405416e-007, -3.42742830e+003, -1.38543335e-005, //err=+6.432e-005
    4951.969, 5000.000, -6.94114294e+001, +3.21250859e-002, -8.41042294e-006, +0.00000000e+000, +0.00000000e+000, -1.38543335e-005, //err=+2.721e-014
    5000.000, 6000.000, +5.68130327e+002, -1.79020300e-002, -2.29105731e-001, +8.80970011e-007, -2.89510883e+004, -6.99491162e-005, //err=+4.832e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

// No JANAF match found for > Tc1(ref)<. $@
// No JANAF match found for > Ru1(ref)<. $@
// No JANAF match found for > Rh1(ref)<. $@
// No JANAF match found for > Pd1(ref)<. $@
// No JANAF match found for > Ag1(ref)<. $@
// No JANAF match found for > Cd1(ref)<. $@
// No JANAF match found for > In1(ref)<. $@
// No JANAF match found for > Sn1(ref)<. $@
// No JANAF match found for > Sb1(ref)<. $@
// No JANAF match found for > Te1(ref)<. $@
{"Tc", 43, "technetium",  98.906200, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
  "DUMMY ENTRY ZERO Barin91: SOL <2473, LIQ <4904.638, Monatomic Gas.",
   "Tm=CRC#52 ... further comment",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,   +0.00000,     2473.0,   +0.00000,   +0.00000,        0.000,   +0.00000,   +0.00000,
        0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ru", 44, "ruthenium", 101.070000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg 28-Sep-97, Barin 1991 p.1251 ref Hu1, SOL<2523, LIQ<4419, Monatomic Gas.",
   "... further comment",
   /* T(ref)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,  +28.53500,   2523.000,  +24.28000,   +9.62300,     4419.000,  +595.54000,   +0.00000,
     298.150,   2523.000,  +4.03569369e+001,  +1.49339030e-002,  +8.07873868e+005,  -1.13537000e-006,  -4.35894408e+002,  +0.00000000e+000, 
    2523.000,   4419.000,  +1.05025146e+002,  +6.14174300e-003,  +1.40969935e+007,  -2.16908000e-007,  -2.96661558e+003,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Rh", 45, "rhodium", 102.905500, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg. 28-Sep-97; Barin 1991 p.1244 ref Hu1, SOL<2233, LIQ<3967, Monatomic Gas",
   "... further comment",
   /* T(ref)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,  +31.50500,   2233.000,  +21.48900,   +9.62300,     3967.000,  +493.26000,   +0.00000,
     298.150,   2233.000,  +3.71683599e+001,  +1.99601230e-002,  +7.29183107e+005,  -1.95282000e-006,  -3.38984709e+002,  +0.00000000e+000, 
    2233.000,   3967.000,  +1.14929310e+002,  +6.06626200e-003,  +1.31457341e+007,  -2.13756000e-007,  -3.07372589e+003,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Pd", 46, "palladium", 106.400000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg. 28-Sep-97, Barin 1991 p.1165 ref Hu1, SOL<1825, LIW<3234, Monatomic Gas",
   "... further comment",
   /* T(ref)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,  +37.82300,   1825.000,  +17.56000,   +9.62200,     3234.000,  +357.55000,   +0.00000,
    298.150,   1825.000,  +4.38063049e+001,  +2.04837720e-002,  +7.35546804e+005,  -2.43502000e-006,  -3.47781952e+002,  +0.00000000e+000, 
    1825.000,   3234.000,  +1.09205342e+002,  +6.51199100e-003,  +5.06382502e+006,  -3.06156000e-007,  -2.41002131e+003,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ag", 47, "silver", 107.868000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1989 p.1 ref Hu1, Regressed 23-Sep-97, SOL<1233.95, LIQ<2433, Monatomic Gas",
   "... further comment",
   /* T(ref)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,  +42.67700,   1234.000,  +11.29700,   +9.15500,     2433.000,  +250.62000,   +0.00000,
    298.150,   1233.950,  +4.11825081e+001,  +2.45359740e-002,  +5.75677855e+005,  -3.69937000e-006,  -2.06631228e+002,  +0.00000000e+000, 
    1233.950,   2433.000,  +1.01307951e+002,  +8.36557300e-003,  +3.57347603e+006,  -5.05035000e-007,  -1.85763217e+003,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Cd", 48, "cadmium", 112.410000, 1,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1989 p359 ref Hu1, reg. 5-Oct-99. Sol<594, Liq<1039, Gas data stops 1500",
   "Tm=594.18 & Tb=1038.15 = CRC#52. Clone gas regs. to 3000 K.",
   /* T(ref)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,   +0.00000,     594.18,   +0.00000,   +0.00000,      1038.15,   +0.00000,   +0.00000,
     298.15,      594.0,     37.73026586,     0.035232899,         430463.3238,      -6.94542E-06,        -11.43107447,  +0.00000000e+000,
     594.0,      1039.0,     78.82615178,     0.021001385,         565483.2612,      -3.40494E-06,       -846.7655364,     +0.00000000e+000,
    1039.0,      1500.0,    347.1140244,     -0.022520337,        -7789111.16,        3.22508E-06,      -8016.761117,    +0.00000000e+000,     /* err 2.46286E-10 */
    1500.0,      3000.0,    347.1140244,     -0.022520337,        -7789111.16,        3.22508E-06,      -8016.761117,    +0.00000000e+000,     /* err 2.46286E-10 */
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"In", 49, "indium", 114.820000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg.30-Sep-97, Barin 1991 p.700 ref Hu1, SOL<429.76, LIQ<2343, Monatomic Gas",
   "... further comment",
   /* T(ref)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,  +57.82300,    429.760,   +3.26400,   +7.59500,     2343.000,  +231.45000,   +0.00000,
     298.150,    429.760,  +4.34710266e+001,  +3.33656610e-002,  +4.18711032e+005,  -3.44522000e-006,  +0.00000000e+000,  +0.00000000e+000, 
     429.760,   2343.000,  +9.32004479e+001,  +1.36211640e-002,  +1.16207802e+006,  -1.36035000e-006,  -9.46143331e+002,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Sn", 50, "tin", 118.690000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
    "Barin91 p1392. ref Hu1. Reg 6oct99. SOL-B(white)<505.06, Liq<2873, Monatomic Gas.",
   "Regressed 2600-3000 K gas (gef-H298/T) but prefer better stuff!",
   /* T(ref)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,  +51.19500,    505.600,   +7.02900,  +13.91700,     2873.000,  +295.76000,   +0.00000,
      298.15,    505.06,      27.2876002,      0.042949045,       319050.6224,       -8.05544E-06,      142.0917132,       +0.00000000e+000, /* err 8.68303E-10 */
      505.06,   2873.0,      104.3653935,      0.010014675,      1133223.913,        -8.04645E-07,    -1329.334845,        +0.00000000e+000, /* err 7.87348E-05 */
      2873.0,   3000.0,     1689.621991,      -0.214120396,      500372613.7,         1.6996E-05,     -62901.06718,		   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Sb", 51, "antimony", 121.750000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg. Barin95 data 5-Oct-99. Sol<904 Liq<1891. std state Sb2(g) >1891.",
   "Tm=903.65+Tb=1653.15 in CRC#52. Clone gas for 2000-3000 K",
   /* T(ref)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,   +0.00000,    903.65,   +0.00000,   +0.00000,     1653.15,   +0.00000,   +0.00000,
        298.15,    904.0,      39.67222475,      0.027840363,          512107.4517,   -4.77508E-06,   -134.4572174,       +0.00000000e+000,
        904.0,    1891.0,     119.2237423,       0.008748439,          627676.7587,   -6.68674E-07,  -2112.506491,		  +0.00000000e+000,
       1891.0,    2000.0,      69.50505872,      0.011739892,       -24076323.54,          0.0,              0.0,		  +0.00000000e+000,
       2000.0,    3000.0,      69.50505872,      0.011739892,       -24076323.54,          0.0,              0.0,		  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Te", 52, "tellurium", 127.600000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 89: p.1479. Std States: SOL <722.65,  LIQ <1327, Te2 GAS >1327 K. ",
   "Tm=722.65+Tb=1262.95 in CRC#52. Clone Te2 reg 1300-2000 for 2000-3000 K. ",
   /* T(ref)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150, +0.00000,   +0.00000,    722.65,   +0.00000,   +0.00000,      1327.00,   +0.00000,   +0.00000,
       298.15,    722.65,     30.03892341,      0.039001569,       364562.9729,     -7.24506E-06,         75.50133926,     +0.00000000e+000,/*  err 1.11227E-07 */
       722.65,   1327.0,     117.3229566,       0.015429348,       769888.6295,     -1.64681E-06,      -1912.401032,       +0.00000000e+000,/*  err 2.00851E-08 */
      1327.0,    2000.0,     461.2027498,      -0.006634842,    -15670000.96,         8.76796E-07,    -10181.85774,        +0.00000000e+000,/*  err 2.12028E-08 */
      2000.0,    3000.0,     461.2027498,      -0.006634842,    -15670000.96,         8.76796E-07,    -10181.85774,        +0.00000000e+000,/*  err 2.12028E-08 */
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

{"I", 53, "iodine", 126.904500, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "I2(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:48 2013
 "... further comment...",
      298.150, +13.19800, +116.14200,   // Tref H298(kJ) & S298(J) ref. element 
      386.750, +15.51700, +40.12000,   // T(K) H(kJ) S(J) melt 
      457.666, +41.96000, +91.68300,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -8.20758503e+001, +3.85323684e-001, +2.28718523e+005, -3.19306203e-004, +1.88569303e+003, -2.16558099e+006, //err=+1.350e-002
     298.150,  386.750, -3.08054071e+001, +2.08967604e-001, +3.42130569e+000, -8.99299670e-005, +1.59957984e+003, -2.16558099e+006, //err=+2.718e-002
     386.750,  457.666, +6.10440775e+001, +1.89373979e-001, -1.56947143e-001, -7.48975859e-005, -1.01921089e+002, -9.36232524e-004, //err=+2.715e-012
     457.666,  800.000, +4.15528025e+002, -2.01239759e-002, -2.15856031e+006, +6.82831143e-006, -5.78000960e+003, -1.02189451e+004, //err=+3.282e-005
     800.000, 2300.000, +3.78565062e+002, +1.11658661e-003, -3.49963742e+006, +4.96952375e-007, -5.04129316e+003, -7.75125092e+003, //err=+1.589e-004
    2300.000, 3000.000, +3.67475297e+002, +5.64935879e-003, -1.15958222e-001, -1.97468793e-007, -4.86504405e+003, -7.39925713e-005, //err=+7.537e-005
    3000.000, 4000.000, +3.57950604e+002, +7.89549259e-003, -7.25625088e-002, -4.35373697e-007, -4.59516427e+003, -3.52053105e-005, //err=+7.182e-005
    4000.000, 5000.000, +3.71033157e+002, +5.73230808e-003, -5.41062766e-002, -2.74362286e-007, -5.03825242e+003, -2.02660131e-005, //err=+6.726e-005
    5000.000, 6000.000, +3.82110265e+002, +4.15911175e-003, -4.30673152e-002, -1.74285778e-007, -5.44222809e+003, -1.31490410e-005, //err=+6.594e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Xe", 54, "xenon", 131.300000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Xe1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:50 2013
 "... further comment...",
      298.150,  +6.19700, +169.68400,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +9.27087011e+001, +1.53227989e-001, +1.03392600e+005, -1.30331515e-004, +7.20740976e+002, -9.49459538e+005, //err=+5.632e-003
     298.150,  800.000, +1.60827626e+002, +2.71002127e-002, +3.73235488e+005, -6.55786279e-006, -4.90256119e+001, +3.38790409e+003, //err=+2.392e-004
     800.000, 2300.000, +1.94566224e+002, +7.70679934e-003, +1.69419454e+006, -6.29423689e-007, -7.30136723e+002, +3.76252940e+003, //err=+2.068e-004
    2300.000, 3000.000, +1.99791580e+002, +5.56697008e-003, -1.94431509e-002, -2.99443064e-007, -8.13015481e+002, -1.24344636e-005, //err=+3.607e-005
    3000.000, 4000.000, +2.04963734e+002, +4.49274030e-003, -1.52988477e-002, -1.99962291e-007, -9.68829766e+002, -7.42257528e-006, //err=+6.356e-005
    4000.000, 5000.000, +2.07887040e+002, +3.93133910e-003, -1.13807871e-002, -1.52456339e-007, -1.05975280e+003, -4.26278048e-006, //err=+6.430e-005
    5000.000, 6000.000, +2.20425947e+002, +2.23761859e-003, -1.21106527e-002, -4.90464395e-008, -1.53037017e+003, -3.69754807e-006, //err=+8.292e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Cs", 55, "cesium", 132.905400, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Cs1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:52 2013
 "... further comment...",
      298.150,  +7.71700, +85.14700,   // Tref H298(kJ) & S298(J) ref. element 
      301.550,  +2.08700,  +6.92200,   // T(K) H(kJ) S(J) melt 
      947.967, +67.65900, +71.37300,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -1.80189367e+001, +1.97231838e-001, +1.33259757e+005, -1.58909347e-004, +9.84639650e+002, -1.23380043e+006, //err=+7.393e-003
     298.150,  301.550, +8.77381324e+001, -1.78650170e-002, +5.85339510e-003, +3.07708066e-005, +0.00000000e+000, -1.23380043e+006, //err=+2.278e-002
     301.550,  800.000, +8.91116767e+001, +3.52811674e-002, +5.37473928e+005, -8.17447619e-006, -3.43293499e+002, +4.85996298e+003, //err=+3.049e-004
     800.000,  947.967, +7.24531501e+001, +4.31800623e-002, +5.64370251e-004, -9.67062487e-006, +0.00000000e+000, +4.85996298e+003, //err=+3.532e-006
     947.967, 2300.000, +2.83016643e+002, -5.21853140e-003, -6.97400893e+006, +7.14036224e-007, -5.11884142e+003, -1.39820048e+004, //err=+1.671e-004
    2300.000, 3000.000, +2.96119257e+002, -6.69485546e-003, -1.35284949e-001, +7.50716490e-007, -5.65694101e+003, -8.65186810e-005, //err=+5.283e-005
    3000.000, 4000.000, +2.85502082e+002, -4.38218035e-003, -8.43794543e-002, +5.23668408e-007, -5.34349570e+003, -4.09385636e-005, //err=+7.738e-005
    4000.000, 5000.000, +3.32863304e+002, -1.10288994e-002, -7.59477919e-002, +9.33455812e-007, -7.07208426e+003, -2.84469575e-005, //err=+7.606e-004
    5000.000, 6000.000, +2.43262459e+002, +1.90348640e-003, -3.01854109e-002, +8.82076035e-008, -3.81439824e+003, -9.21601923e-006, //err=+6.510e-004
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ba", 56, "barium", 137.330000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Ba1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:53 2013
 "... further comment...",
      298.150,  +6.91200, +62.47500,   // Tref H298(kJ) & S298(J) ref. element 
     1000.000,  +8.01200,  +8.01200,   // T(K) H(kJ) S(J) melt 
     2118.599, +140.27800, +66.21300,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +2.67251880e+002, -6.18633440e-001, +6.26240477e+005, +8.79060329e-004, -1.81539178e+003, -9.50450816e+006, //err=+1.006e-001
     298.150,  582.530, +6.33430363e+001, +6.20379327e-003, +4.68469738e+005, +2.12079382e-005, -1.70475564e+002, +3.12925309e+003, //err=+4.155e-005
     582.530,  768.130, +7.04743148e+001, +1.34863047e-002, -2.28688764e-001, +7.01355077e-006, -2.95407858e+002, -8.77260611e-004, //err=+2.567e-011
     768.130,  800.000, +5.05484509e+001, +3.09381864e-002, +2.46912671e-004, +0.00000000e+000, +0.00000000e+000, -8.77260611e-004, //err=+1.071e-012
     800.000, 1000.000, +4.53325371e+001, +4.38878106e-002, +3.42127241e-004, -8.19429306e-006, +2.84432220e+000, -8.77260611e-004, //err=+7.220e-011
    1000.000, 2118.599, +1.53520176e+002, +5.67731848e-003, +6.09902930e+006, -5.51214508e-008, -2.66027472e+003, +1.21832417e+004, //err=+1.265e-004
    2118.599, 2300.000, -7.30306366e+001, +1.22763056e-001, -9.02543640e-005, -1.74206792e-005, +0.00000000e+000, +1.21832417e+004, //err=+5.913e-007
    2300.000, 3000.000, +4.00315200e+002, -2.15321152e-002, -2.82176046e-001, +2.34556943e-006, -1.17991932e+004, -1.80459833e-004, //err=+1.026e-004
    3000.000, 4000.000, +3.06412189e+002, -6.09988716e-004, -1.43017647e-001, +2.42137458e-007, -9.05687515e+003, -6.93881835e-005, //err=+1.379e-004
    4000.000, 5000.000, +2.71535411e+002, +5.50680515e-003, -8.50509640e-002, -2.41475156e-007, -7.90917751e+003, -3.18919395e-005, //err=+8.768e-005
    5000.000, 6000.000, +2.75602184e+002, +4.79298796e-003, -6.36722110e-002, -1.88022081e-007, -8.03884827e+003, -1.94544680e-005, //err=+2.133e-004
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

// No JANAF match found for > La1(ref)<. $@
// No JANAF match found for > Ce1(ref)<. $@
// No JANAF match found for > Pr1(ref)<. $@
// No JANAF match found for > Nd1(ref)<. $@
// No JANAF match found for > Pm1(ref)<. $@
// No JANAF match found for > Sm1(ref)<. $@
// No JANAF match found for > Eu1(ref)<. $@
// No JANAF match found for > Gd1(ref)<. $@
// No JANAF match found for > Tb1(ref)<. $@
// No JANAF match found for > Dy1(ref)<. $@
// No JANAF match found for > Ho1(ref)<. $@
// No JANAF match found for > Er1(ref)<. $@
// No JANAF match found for > Tm1(ref)<. $@
// No JANAF match found for > Yb1(ref)<. $@
// No JANAF match found for > Lu1(ref)<. $@
{"La", 57, "lanthanum", 138.905500, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1989 p.779 ref Hu1. SOL-A <550, SOL-B <1134, SOL-C <1193, Liq <3726, Monatomic Gas. REDO!",
   "A-B: H=0.364kJ S=0.662J,  B-C: H=3.121kJ S=2.752J",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +56.90200,   1193.000,   +6.19700,   +5.19400,     3726.000,  +413.72000,   +0.00000,
      298.15,     550.0,     23.57514212,       0.057383796,      273150.5071,        -1.93947E-05,    256.7459596,       +0.00000000e+000,
      550.0,     1134.0,     66.00862321,       0.01919818,       767479.1073,        -1.68085E-06,   -409.8554488,		  +0.00000000e+000,
     1134.0,     1193.0,     49.23054237,       0.021881356,           0.0,                0.0,           0.0,			  +0.00000000e+000,
     1193.000,   3726.000, +1.23342497e+002,  +7.31808100e-003,  +4.63293455e+006,  -3.69757000e-007,  -2.05392332e+003,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ce", 58, "cerium", 140.120000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1991 reg. 30mar06: p.371 ref Hu1, SOL-C <999, SOL-D <1071, LIQ <3198, Monatomic Gas.",
   "sol+liq regressed",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +69.45400,   1071.000,   +5.46000,   +5.09800,     3695.000,  +414.20000,   +0.00000,
		298.15,  3695.0,  59.16023754,  0.031401481,  594250.4405,  -3.35645E-06,  -92.26854392,       +0.00000000e+000, +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Pr", 59, "praseodymium", 140.907700, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1991 p.1171 ref Hu1;  SOL-A <1068, SOL-B <1204, LIQ <3780, Monatomic Gas.",
   "A->B dH=3.167kJ  dS=2.965J",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +73.93100,   1799.000,   +6.88700,   +5.72000,     3780.000,  +296.78000,   +0.00000,
     298.150,   1204.000,  +9.29301936e+001,  +8.98860200e-003,  +9.11648575e+005,  +3.91181000e-006,  -5.57310144e+002,  +0.00000000e+000, 
    1204.000,   3780.000,  +1.45675925e+002,  +9.45430000e-003,  +6.89951169e+006,  -4.78440000e-007,  -2.32867011e+003,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Nd", 60, "neodymium", 144.240000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1991 p.1034 ref Hu1, SOL-A <1128, SOL-B <1289, LIQ <3337, Monatomic Gas.",
   "A->B dH=3.029kJ  dS=2.685J",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +71.08600,   1289.000,   +7.10000,   +5.50800,     3337.000,  +273.00000,   +0.00000,
     298.150,   1289.000,  +8.75188814e+001,  +1.16095660e-002,  +8.94318113e+005,  +2.95424000e-006,  -5.21644062e+002,  +0.00000000e+000, 
    1289.000,   3337.000,  +1.40951910e+002,  +1.15066680e-002,  +8.24980404e+006,  -6.15140000e-007,  -2.38020843e+003,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Pm", 61, "promethium", 145.000000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "DUMMY ENTRY ZERO Barin91 no data",
   "Tm+Tb=CRC#52 ... further comment",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    1308.15,   +0.00000,   +0.00000,     3003.15,   +0.00000,   +0.00000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Sm", 62, "samarium", 150.400000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1991 p.1385 ref Hu1. 6oct99.  SOL A->B 1190K; Liq 1345-2061. Monatomic gas.",
   "A-B: dH=3.113kJ  dS=2.616J, Use 1600-2100 gas data for regsn.",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +69.49600,   1345.000,   +8.61900,   +6.40800,     2061.000,  +166.41000,   +0.00000,
     298.15,    1190.0,    41.35097919,       0.049440854,        367654.4469,       -8.88976E-06,     173.7026866,       +0.00000000e+000,
    1190.0,     1345.0,    56.51460616,       0.037153189,       -1801389.718,       -4.62949E-06,             0.0,		  +0.00000000e+000,
    1345.000,   2061.000,  +1.55381962e+002,  +1.04301220e-002,  +7.95848696e+006,  -4.46933000e-007,  -2.78307061e+003,  +0.00000000e+000, 
	2061.0,     3000.0,   641.2426554,        -0.057757406,      12833638.82,        9.03911E-06,       -18410.29252,	  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Eu", 63, "europium", 151.960000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin89 p.525 reg 5oct99. Sol<1090, Liq<1798, Monatomic gas (clone reg. to T>2000).",
   "Tm=1099.15 Tb=1712.15 in CRC#52. ",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    1090.0,   +0.00000,   +0.00000,     1798.0,   +0.00000,   +0.00000,
         298.15,    1090.0,   75.43071751,    0.026218764,          597527.6282,    -3.14182E-06,      -204.908675,       +0.00000000e+000,
        1090.0,     1798.0,  126.8227979,     0.013827824,         2641232.581,     -1.18082E-06,     -1589.2993,		  +0.00000000e+000,
        1798.0,     2000.0,  106.8048152,     0.02297512,         -119256221.8,      0.0,                 0.0,			  +0.00000000e+000,
        2000.0,     3000.0,  106.8048152,     0.02297512,         -119256221.8,      0.0,                 0.0,			  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Gd", 64, "gadolinium", 157.250000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg 30-Sep-97, Barin 1991 p.606 ref Hu1, SOL-A <1533, SOL-B <1585, LIQ <3535, Monatomic Gas.)",
   "A->B dH=3.912 kJ dS=2.552 J, ALL solid regressed together",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +74.89400,   1585.000,  +11.05800,   +6.57400,     3535.000,  +230.00000,   +0.00000,
     298.150,   1585.000,  +7.67735792e+001,  +2.04074200e-002,  +7.76781560e+005,  -2.05673000e-006,  -4.05133386e+002, +0.00000000e+000, 
    1585.000,   3535.000,  +1.41748116e+002,  +7.13050800e-003,  +6.21147397e+006,  -3.33476000e-007,  -2.41050557e+003, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Tb", 65, "terbium", 158.925400, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1991 p.1464 ref Hu1. Reg 6oct99. SOL-A<1560 SOL-B<1630 LIQ<3492 Monatomic Gas)",
   "A->B 1560K dH=5.021kJ  dS=3.219J. ",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +73.30400,   1630.000,  +10.79500,   +6.62300,     3492.000,  +330.87000,   +0.00000,
     298.15,    1560.0,      77.12766818,        0.022369396,        700045.8726,   -2.04296E-06,     -313.9939643,       +0.00000000e+000, /* err 0.000471976 */
    1560.0,     1630.0,      86.82351286,        0.012201792,     -15719371.86,       0.0,               0.0,             +0.00000000e+000, /* err 2.95632E-23 */
    1630.000,   3492.000,  +1.48325942e+002,  +9.37623100e-003,  +9.59997773e+006,  -4.42646000e-007,  -2.63435292e+003,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Dy", 66, "dysprosium", 162.500000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg 30-Sep-97, Barin 1991 p.507 ref Hu1, SOL-A <1657, SOL-B <1682, LIQ <2831, Monatomic Gas.",
   "A->B dH=4.163  dS=2.512J, all solid regressed together.",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +74.89400,   1682.000,  +11.05800,   +6.57400,     2831.000,  +230.00000,   +0.00000,
     298.150,   1682.000,  +8.88293069e+001,  +1.58617930e-002,  +8.80505987e+005,  -7.41739000e-007,  -4.92042293e+002, +0.00000000e+000, 
    1682.000,   2831.000,  +1.38050849e+002,  +1.14424030e-002,  +1.06705052e+007,  -6.00479000e-007,  -2.36255448e+003, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ho", 67, "holmium", 164.930400, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg 30-Sep-97, Barin 1991 p.690 ref Hu1, SOL-A <1701, SOL-B <1743, LIQ <2964, Monatomic Gas.)",
   "A->B dH=4.690kJ dS=2.757 J, all solid regressed together",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +75.01900,   1743.000,  +12.18000,   +6.98800,     2964.000,  +242.50000,   +0.00000,
     298.150,   1743.000,  +9.05351593e+001,  +1.45624370e-002,  +9.10385073e+005,  -3.72552000e-007,  -5.18979769e+002, +0.00000000e+000, 
    1743.000,   2964.000,  +1.47245183e+002,  +8.96275900e-003,  +8.30273566e+006,  -4.36384000e-007,  -2.57022666e+003, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Er", 68, "erbium", 167.260000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "30-Sep-97, Barin 1991 p.515 ref Hu1, SOL <1795, LIW <3132, Monatomic Gas.)",
   "... further comment",
  /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +73.17800,   1795.000,  +19.90300,  +11.08800,     3132.000,  +261.40000,   +0.00000,
     298.150,   1795.000,  +8.20460243e+001,  +1.98651390e-002,  +8.13688647e+005,  -1.95719000e-006,  -4.10315610e+002,  +0.00000000e+000,
    1795.000,   3132.000,  +1.50619822e+002,  +7.51368000e-003,  +5.33400959e+006,  -3.68197000e-007,  -2.65166544e+003,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Tm", 69, "thulium", 168.934200, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "DUMMY ENTRY ZERO Barin 91: SOL <1818, LIQ<2217, Monatomic Gas",
   "Tm+Tb=CRC#52 ... further comment",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    1818.15,   +0.00000,   +0.00000,     2000.15,   +0.00000,   +0.00000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
/* Yb is not included in runs <25-Sep-02 because of "poor data"... what did that mean? */
{"Yb", 70, "ytterbium", 173.040000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg. 6oct99 Barin 95 Std State: Sol-A<1033, Sol-B<1097, Liq <1465, Monatomic Gas",
   "Tm=1097.15,Tb=1700.15=CRC#52 ",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    1097.00,   +0.00000,   +0.00000,     1465.00,   +0.00000,   +0.00000,
      298.15,     1033.0,      38.8060157,       0.042477876,       383151.7595,    -9.6968E-06,          84.83888693,   +0.00000000e+000,
      1033.0,     1097.0,      52.37689063,      0.022234375,            0.0,        0.0,                  0.0,          +0.00000000e+000,/* err 3.95819E-26 */
      1097.0,     1465.0,     130.3586315,       0.005419808,      4419948.35,       2.71375E-07,      -2104.357598,     +0.00000000e+000,/* err 5.77924E-09 */
      1465.0,     2000.0,     342.1877706,      -0.01240622,     -18255421.64,       1.24922E-06,      -8892.902751,     +0.00000000e+000,/* err 3.91692E-08 */
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Lu", 71, "lutetium", 174.967000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1989: p.844. Regr gef 5oct99. Lu SOL <1936, LIQ <3664. monatomic GAS >3664K. ",
   "Tm=1925+Tb=3600,CRC#52. ",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    1925.15,   +0.00000,   +0.00000,     3600.15,   +0.00000,   +0.00000,
       298.15,   1936.0,     63.4739629,       0.016029987,        839165.7498,      -1.06778E-06,     -459.7911532,    +0.00000000e+000,/* err  0.000356492 */
      1936.0,    3664.0,    110.4800633,       0.010983877,       8954550.852,       -5.6374E-07,     -2275.657636,     +0.00000000e+000,/* err  2.73982E-06 */
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,+0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,+0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,+0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,+0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},


{"Hf", 72, "hafnium", 178.490000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Hf1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:54 2013
 "... further comment...",
      298.150,  +5.84200, +43.56000,   // Tref H298(kJ) & S298(J) ref. element 
     2500.000, +29.28800, +11.71500,   // T(K) H(kJ) S(J) melt 
     4963.793, +560.20400, +112.85800,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +3.31182691e+003, -1.15681955e+001, +3.07409456e+006, +1.89977098e-002, -2.66681290e+004, -4.45846031e+007, //err=+2.203e+000
     298.150,  800.000, +2.91725575e+001, +3.57270044e-002, +4.24193035e+005, -7.66010897e-006, -6.13864176e+000, +3.85045170e+003, //err=+3.288e-004
     800.000, 2054.000, +6.56759173e+001, +1.42089456e-002, +1.75936229e+006, -9.65398358e-007, -7.31878956e+002, +4.05647431e+003, //err=+1.652e-004
    2054.000, 2300.000, +1.11260679e+002, +2.78706602e-003, -6.27274389e-002, +4.29546244e-007, -1.98236803e+003, +4.05647431e+003, //err=+1.883e-007
    2300.000, 2500.000, +3.53851100e+001, +2.38444233e-002, +3.69557086e-005, -2.20180304e-006, +1.35503966e+000, +4.05647431e+003, //err=+1.264e-007
    2500.000, 3000.000, +1.34367038e+002, +5.21437351e-003, -7.33624582e-002, -1.45409370e-007, -3.26160860e+003, -4.49509322e-005, //err=+5.757e-005
    3000.000, 4000.000, +1.31693262e+002, +5.98545616e-003, -5.04494053e-002, -2.40866305e-007, -3.19480829e+003, -2.44766479e-005, //err=+8.528e-005
    4000.000, 4963.793, +1.36262186e+002, +5.15965817e-003, -3.59424470e-002, -1.74208606e-007, -3.34229000e+003, -1.34736198e-005, //err=+5.144e-005
    4963.793, 5000.000, -4.25816557e+001, +3.07675311e-002, -5.14716180e-006, +0.00000000e+000, +0.00000000e+000, -1.34736198e-005, //err=+2.010e-014
    5000.000, 6000.000, +5.81538436e+002, -1.70157275e-002, -2.25672176e-001, +7.23621156e-007, -2.85172050e+004, -6.89008049e-005, //err=+9.731e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"Ta", 73, "tantalum", 180.947900, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Ta1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:56 2013
 "... further comment...",
      298.150,  +5.68100, +41.47100,   // Tref H298(kJ) & S298(J) ref. element 
     3258.000, +36.56800, +11.22400,   // T(K) H(kJ) S(J) melt 
     5778.070, +738.71300, +127.84800,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -5.56266883e+001, +1.89534475e-001, +9.48003462e+004, -1.59308454e-004, +9.27383413e+002, -9.16663613e+005, //err=+6.573e-003
     298.150,  800.000, +2.85986607e+001, +3.44309610e-002, +4.31512387e+005, -7.87974726e-006, -2.67042936e+001, +3.91689044e+003, //err=+3.183e-004
     800.000, 2300.000, +7.09835476e+001, +1.05442480e-002, +2.14159214e+006, -7.28283674e-007, -8.90003282e+002, +4.75612643e+003, //err=+5.466e-004
    2300.000, 3000.000, +8.14809210e+001, +6.45834516e-003, -2.59242418e-002, -9.42953169e-008, -1.08402234e+003, -1.65793107e-005, //err=+6.747e-005
    3000.000, 3258.000, +1.75745582e+002, -1.40388098e-002, -7.08335550e-002, +1.91355090e-006, -3.86884434e+003, -1.65793107e-005, //err=+2.214e-012
    3258.000, 4000.000, +9.22325648e+001, +9.76343442e-003, -3.09274272e-002, -4.76473594e-007, -2.08032070e+003, -1.43844689e-005, //err=+4.698e-005
    4000.000, 5000.000, +1.12093887e+002, +6.32496938e-003, -2.94106374e-002, -2.07613734e-007, -2.73865113e+003, -1.10160300e-005, //err=+8.681e-005
    5000.000, 5778.070, +1.08521293e+002, +6.71447977e-003, -2.10247062e-002, -2.26151557e-007, -2.59097472e+003, -6.52358641e-006, //err=+4.672e-005
    5778.070, 6000.000, -2.00705941e+002, +7.69201517e-002, -3.47443222e-005, -4.13337947e-006, -4.90669911e+000, -6.52358641e-006, //err=+8.907e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"W", 74, "tungsten", 183.850000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "W1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:27:58 2013
 "... further comment...",
      298.150,  +4.97300, +32.66000,   // Tref H298(kJ) & S298(J) ref. element 
     3680.000, +35.39700,  +9.61800,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -6.17361432e+001, +1.81204487e-001, +7.34815919e+004, -1.49776872e-004, +9.12996336e+002, -6.85691990e+005, //err=+5.860e-003
     298.150,  800.000, +2.06577081e+001, +3.28039095e-002, +4.20424766e+005, -7.43901818e-006, -3.18822500e+001, +3.81624679e+003, //err=+2.713e-004
     800.000, 2300.000, +5.86258569e+001, +1.08296006e-002, +1.87402662e+006, -6.92021732e-007, -7.94897526e+002, +4.16190708e+003, //err=+2.708e-004
    2300.000, 3000.000, +7.05123400e+001, +6.78271544e-003, -2.50362218e-002, -1.19047083e-007, -1.04688978e+003, -1.60113960e-005, //err=+1.796e-004
    3000.000, 3680.000, +1.29546647e+002, -6.47719307e-003, -4.62016895e-002, +1.22459117e-006, -2.76384428e+003, -2.32368123e-005, //err=+1.144e-004
    3680.000, 4000.000, +1.84056401e+002, -6.42449182e-003, -7.61295067e-002, +6.98131265e-007, -5.64982104e+003, -3.30993038e-005, //err=+6.065e-005
    4000.000, 5000.000, +1.23848512e+002, +4.04083889e-003, -3.93314732e-002, -1.19152708e-007, -3.66245661e+003, -1.47319720e-005, //err=+4.634e-005
    5000.000, 6000.000, +1.24366047e+002, +3.93330871e-003, -2.90919889e-002, -1.10553215e-007, -3.67622728e+003, -8.88218250e-006, //err=+4.751e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
// No JANAF match found for > Re1(ref)<. $@
// No JANAF match found for > Os1(ref)<. $@
// No JANAF match found for > Ir1(ref)<. $@
{"Re", 75, "rhenium", 186.207000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1991 p.1233 ref Hu1, SOL <3453, LIQ <5864, Monatomic Gas.",
   "... further comment",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +35.52600,   3453.000,  +33.22900,   +9.62300,     5800.000,  +714.84000,   +0.00000,
     298.150,   3453.000,  +5.39446546e+001,  +1.38256000e-002,  +1.00317553e+006,  -9.63050000e-007,  -5.64592078e+002,    +0.00000000e+000, 
    3453.000,   5864.000,  +1.30143989e+002,  +4.27519600e-003,  +2.38504525e+007,  -1.08587000e-007,  -3.81089444e+003,    +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,    +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,    +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,    +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,    +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},
{"Os", 76, "osmium", 190.200000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg. 28-Sep-97, Barin 1991 p.1098 ref Hu1, SOL <3300, LIW <5281, Monatomic Gas.",
   "... further comment",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +32.63500,   3300.000,  +31.75700,   +9.62300,     5281.000,  +746.00000,   +0.00000,
     298.150,   3300.000,  +4.96311584e+001,  +1.33377050e-002,  +9.65790048e+005,  -1.03080000e-006,  -5.47513458e+002,  +0.00000000e+000, 
    3300.000,   5281.000,  +1.15831846e+002,  +4.21588700e-003,  +1.12974411e+007,  -1.24491000e-007,  -3.23792296e+003,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},
{"Ir", 77, "iridium", 192.220000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg. 23-Sep-97, Barin 1989 p.727 ref Hu1, No transitions.  Monatomic Gas.",
   "... further comment",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +35.50500,   2716.000,  +26.13700,   +9.62300,     4697.000,  +604.10000,   +0.00000,
     298.150,   2716.000,  +4.79399778e+001,  +1.56506750e-002,  +8.51808203e+005,  -1.22500000e-006,  -4.58507732e+002,   +0.00000000e+000, 
    2716.000,   4697.000,  +1.20784868e+002,  +5.32071200e-003,  +1.71010345e+007,  -1.65983000e-007,  -3.31258672e+003,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},


{"Pt", 78, "platinum", 195.090000, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Reg. 28-Sep-97, Barin 1991 p.1184 ref Hu1, Monatomic Gas.",
   "... further comment",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    +0.00000,  +41.63100,   2045.000,  +19.66500,   +9.61600,     4096.000,  +509.82000,   +0.00000,
     298.150,   2045.000,  +4.96436930e+001,  +1.90676190e-002,  +7.72096590e+005,  -2.08754000e-006,  -3.83125598e+002,   +0.00000000e+000,  
    2045.000,   4096.000,  +1.21341002e+002,  +5.07515400e-003,  +7.77420135e+006,  -1.86656000e-007,  -2.76547941e+003,   +0.00000000e+000,  
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},
{"Au", 79, "gold", 196.966500, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1989 p.92 ref Hu1, Reg. 23-Sep-97, Monatomic Gas.",
   "... further comment",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    +0.00000,  +47.49700,   1337.580,  +12.55200,   +9.38400,     3127.000,  +334.38000,   +0.00000,
     298.150,   1337.580,  +4.84791953e+001,  +2.29550900e-002,  +6.18375044e+005,  -3.36820000e-006,  -2.50044629e+002,   +0.00000000e+000,  
    1337.580,   3127.000,  +1.10930746e+002,  +6.67882100e-003,  +3.35734966e+006,  -3.57308000e-007,  -1.99055726e+003,   +0.00000000e+000,  
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},

// ==========================================================================================================

{"Hg", 80, "mercury", 200.590000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Hg1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:29:59 2013
 "... further comment...",
      298.150,  +9.34300, +76.02800,   // Tref H298(kJ) & S298(J) ref. element 
      234.290,  +2.29500,  +9.79700,   // T(K) H(kJ) S(J) melt 
      629.839, +59.20500, +94.00100,   // T(K) H(kJ) S(J) vapor
      25.000,  234.290, -7.25780935e+001, +2.78456404e-001, +1.42943118e+005, -2.72795172e-004, +1.48043832e+003, -1.26760186e+006, //err=+4.049e-003
     234.290,  298.150, +9.92655466e+001, -1.59446286e-001, +8.96094046e-003, +2.73376396e-004, +0.00000000e+000, -1.26760186e+006, //err=+4.206e-002
     298.150,  629.839, +6.11282953e+001, +3.95504146e-002, +4.65558527e+005, -1.08241376e-005, -2.01623265e+001, +4.59137044e+003, //err=+5.170e-005
     629.839,  800.000, -9.45562901e+001, +3.92116848e-001, -1.15006242e-003, -1.77211232e-004, +0.00000000e+000, +4.59137044e+003, //err=+7.644e-006
     800.000, 2300.000, +2.68243919e+002, -3.20462738e-003, -4.95996842e+006, +5.07499184e-007, -4.31431993e+003, -1.10152795e+004, //err=+3.181e-004
    2300.000, 3000.000, +2.71348290e+002, -2.34378340e-003, -1.08609576e-001, +2.64372941e-007, -4.54151013e+003, -6.94590001e-005, //err=+4.576e-005
    3000.000, 4000.000, +2.63377077e+002, -5.93904268e-004, -6.80116535e-002, +9.09871732e-008, -4.30697237e+003, -3.29973621e-005, //err=+5.851e-005
    4000.000, 5000.000, +2.57583872e+002, +3.85672860e-004, -4.41682798e-002, +1.63352615e-008, -4.11284895e+003, -1.65436433e-005, //err=+8.058e-005
    5000.000, 6000.000, +2.56490601e+002, +5.36253693e-004, -3.22283670e-002, +7.14699605e-009, -4.07255766e+003, -9.83976170e-006, //err=+5.439e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
// No JANAF match found for > Tl1(ref)<. $@
{"Tl", 81, "thallium", 204.370000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
    "DUMMY ENTRY ZERO Barin. SOL-A <507, SOL-B <577, LIQ <1744, Monatomic Gas >1744.",
   "Tm+Tb=CRC#52 ... further comment",
   /* Tref(K)Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    576.65,   +0.00000,   +0.00000,      1730.15,   +0.00000,   +0.00000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},

{"Pb", 82, "lead", 207.200000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Pb1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:30:01 2013
 "... further comment...",
      298.150,  +6.87800, +64.78500,   // Tref H298(kJ) & S298(J) ref. element 
      600.600,  +4.77400,  +7.94800,   // T(K) H(kJ) S(J) melt 
     2019.022, +177.58200, +87.95500,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, -3.25245983e+001, +1.90928002e-001, +1.22350241e+005, -1.59758360e-004, +9.19355004e+002, -1.15576997e+006, //err=+7.055e-003
     298.150,  600.600, +4.40476446e+001, +4.32893402e-002, +3.85960078e+005, -1.12733592e-005, +7.75490070e+001, +2.62497318e+003, //err=+7.306e-005
     600.600,  800.000, +4.22634504e+001, +5.64487937e-002, +5.33409319e-004, -1.64991958e-005, +0.00000000e+000, +2.62497318e+003, //err=+4.864e-006
     800.000, 2019.022, +1.17362548e+002, +8.44663124e-003, +2.29132945e+006, -5.79162028e-007, -1.42739061e+003, +5.31328115e+003, //err=+1.698e-004
    2019.022, 2300.000, +5.02726652e+002, -4.54741916e-002, -4.77116610e-001, +5.09178097e-006, -1.48648492e+004, +5.31328115e+003, //err=+2.531e-007
    2300.000, 3000.000, +4.22170859e+002, -2.20088963e-002, -3.06278777e-001, +2.00631929e-006, -1.28070490e+004, -1.95874234e-004, //err=+1.749e-004
    3000.000, 4000.000, +3.61171765e+002, -8.50357733e-003, -1.74019703e-001, +6.57295075e-007, -1.10201416e+004, -8.44295184e-005, //err=+1.273e-004
    4000.000, 5000.000, +3.20314829e+002, -1.48106771e-003, -1.03761344e-001, +1.13085692e-007, -9.66201843e+003, -3.88647840e-005, //err=+3.055e-005
    5000.000, 6000.000, +3.12174794e+002, -2.80306458e-004, -7.41615313e-002, +3.41672707e-008, -9.37146807e+003, -2.26425308e-005, //err=+4.030e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

// No JANAF match found for > Bi1(ref)<. $@
// No JANAF match found for > Po1(ref)<. $@
// No JANAF match found for > At1(ref)<. $@
{"Bi", 83, "bismuth", 208.980400, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1989 p.190 ref Hu1, Reg. 23-Sep-97, SOL <544, LIQ <1934, Add gas Bi(g) 5oct99",
   "Add 2000-3000 clone of gas regression. ",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +56.73500,    544.520,  +11.29700,  +20.74700,     1934.000,  +187.29100,   +0.00000,
     298.150,    544.520,  +5.18495911e+001,  +2.34574570e-002,  +4.82197918e+005,  +2.65497000e-008,  -1.30111178e+002,  +0.00000000e+000, 
     544.520,   1934.000,  +1.21417311e+002,  +9.00556500e-003,  +8.13354230e+005,  -7.98863000e-007,  -1.59016315e+003,  +0.00000000e+000,
     1934.0,     2000.000,    -24.32826316,      0.064202632,    +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
     2000.0,     3000.000,    -24.32826316,      0.064202632,    +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},
{"Po", 84, "polonium", 209.000000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "DUMMY ENTRY ZERO Barin91 no data",
   "Tm+Tb=CRC#52 ... further comment",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +56.73500,    544.520,  +11.29700,  +20.74700,     1934.000,  +187.29100,   +0.00000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},
{"At", 85, "astatine", 210.000000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "DUMMY ENTRY ZERO Barin91 no data",
   "... further comment",
   /* Tref(K)  Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,      0.000,   +0.00000,   +0.00000,        0.000,   +0.00000,   +0.00000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},
   
{"Rn", 86, "radon", 222.000000, 1,           /*  sym, z, name, atom wt., flag data ok?(T/F) */
 "Rn1(ref) JANAF gef-modHF76 Cp form:",         // gef-modHF76 Cp form: (Chase+ 1998) Sun Jul 14 16:30:03 2013
 "... further comment...",
      298.150,  +6.19700, +176.23500,   // Tref H298(kJ) & S298(J) ref. element 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) melt 
        0.000,  +0.00000,  +0.00000,   // T(K) H(kJ) S(J) vapor
      25.000,  298.150, +9.92597011e+001, +1.53227989e-001, +1.03392600e+005, -1.30331515e-004, +7.20740976e+002, -9.49459538e+005, //err=+5.632e-003
     298.150,  800.000, +1.67171530e+002, +2.73028108e-002, +3.71069399e+005, -6.65515652e-006, -4.59228446e+001, +3.36824222e+003, //err=+2.240e-004
     800.000, 2300.000, +2.00965339e+002, +7.75115841e-003, +1.67654330e+006, -6.35779478e-007, -7.25975569e+002, +3.72332889e+003, //err=+2.218e-004
    2300.000, 3000.000, +2.06342580e+002, +5.56697008e-003, -1.94431509e-002, -2.99443064e-007, -8.13015481e+002, -1.24344636e-005, //err=+3.607e-005
    3000.000, 4000.000, +2.11514734e+002, +4.49274030e-003, -1.52988477e-002, -1.99962291e-007, -9.68829766e+002, -7.42257528e-006, //err=+6.356e-005
    4000.000, 5000.000, +2.16629768e+002, +3.60441876e-003, -1.22187805e-002, -1.30602604e-007, -1.13778483e+003, -4.57665879e-006, //err=+6.703e-005
    5000.000, 6000.000, +2.21333501e+002, +2.93632748e-003, -1.03638107e-002, -8.79168787e-008, -1.30962939e+003, -3.16421330e-006, //err=+9.272e-005
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},

// No JANAF match found for > Fr1(ref)<. $@
// No JANAF match found for > Ra1(ref)<. $@
// No JANAF match found for > Ac1(ref)<. $@
// No JANAF match found for > Th1(ref)<. $@
// No JANAF match found for > Pa1(ref)<. $@
// No JANAF match found for > U1(ref)<. $@
{"Fr", 87, "francium", 223.000000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "DUMMY ENTRY ZERO Barin91 no data",
   "... further comment",
   /* Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    +0.00000,   +0.00000,      0.000,   +0.00000,   +0.00000,        0.000,   +0.00000,   +0.00000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},
{"Ra", 88, "radium", 226.025400, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "DUMMY ENTRY ZERO Barin91 no data",
   "Tm+Tb(<1737C!)=CRC#52 ... further comment",
   /* Tref(K)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    973.15,   +0.00000,   +0.00000,     2010.15,   +0.00000,   +0.00000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},
{"Ac", 89, "actinium", 227.000000, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "DUMMY ENTRY ZERO Barin91 no data",
   "Tm+Tb(+/-300!)=CRC#52 ... further comment",
   /* Tref(K)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,    1323.15,   +0.00000,   +0.00000,      3473.00,   +0.00000,   +0.00000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, 
},
{"Th", 90, "thorium", 232.038100, 1,   /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "Barin 1991 p.1493 ref Hu1, reg. 298-3000K 30-Mar-2006.  SOL-A <1636 SOL-B <2028 LIQ <5056.",
   "A->B dH=2.736kJ  dS=1.672J",
   /* Tref(K)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +53.38800,   2028.000,  +16.12100,   +7.94900,     5056.000,  +514.14000,   +0.00000e+000,
	298.150,   3000.000,    68.09044725,  0.015877133,  935741.1011,  -1.37263E-07,  -517.0419665,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,   +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},																														
{"Pa", 91, "protactinium", 231.035900, 0,    /*  sym, z, name, atom wt., flag data ok?(T/F) */
   "DUMMY ENTRY ZERO Barin91: SOL-A <1443, SOL-B <1845, LIQ <2500. Monatomic Gas",
   "... further comment",
   /* Tref(K)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,   +0.00000,      0.000,   +0.00000,   +0.00000,        0.000,   +0.00000,   +0.00000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,  +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,  +0.00000000e+000,
},
{"U", 92, "uranium", 238.029000, 1,    /*  sym, z, name, atom wt., flag data ok?(T/F)              */
   "Reg. 30-Mar-06, Barin 1989 p.1579 ref Hu1, SOL-A <941, SOL-B <1048, SOL-C <1405, LIQ <4402, Monatomic Gas. ",
   "A->B 941 K  B->C 1048 K MELT 1405 K",
   /* Tref(K)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +50.29200,   1405.000,   +8.51900,   +6.06300,     4402.000,  +464.11000,   +0.00000,
     298.150,   3000.000,       13.32339669,       0.045716667,       -51182.8001,      -5.28445E-06,       420.9156277,  +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
},
{"e-", 93, "electron", 0.00054858, 1,    /*  sym, z, name, atom wt., flag data ok?(T/F)  M from JANAF hardcopy.  */
   "March 1982 JANAF: Electron Gas  regression of Giaque function -[G(T)-H(298)]/T  3feb2013",
   "... further comment",
   /* Tref(K)    Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) */
    298.150,  +0.00000,  +20.979,       0.000,   0.000,      0.000,         0.000,   0.000,       0.00000,
     298.150,   6000.000,       45.8897031,    0.006690,          1142860.9,        -3.84022E-07,     -682.66477,         +0.00000000e+000,
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
       0.000,    0.000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000, +0.00000000e+000,
}
};

int elsN = (sizeof els / sizeof (struct _Els) );

/* REMOVED:  15-July-05
{"D",  1, "deuterium",   2.00, 0,       / *  sym, z, name, atom wt., flag data ok?(T/F) * /
   0.0e+0,  0.0e+0,  0,                 / * solar, Orgueil abunds.(AG89 to 10^6), flag present?(T/F) * /
   / * Hzero,    S298,         Tmelt,   dHmelt(kJ), dSmelt(J),      Tboil,   dHboil(kJ),  dSboil(J) * /
    +0.00000,  +000.0000,      0.000,   +0.00000,   +0.00000,        0.000,   +0.00000,   +0.00000,
   "No data yet. Included in this file 26-Jul-99.",
   "... further comment",
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
       0.000,      0.000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000,  +0.00000000e+000, 
}
*/

#endif  /*  _Elm_Struct_Data_h  */
